package gov.va.med.ccht.model.car;

import java.io.Serializable;

public class CensusActivityVisnRecord implements Serializable {

	private static final long serialVersionUID = 1379373488191465783L;
	
	private Integer visnId = 0;
	private Integer patientTotals = 0;
	private Integer dialogue = 0;
	private Integer messagingByDevice = 0;
	private Integer messagingByIVR = 0;
	private Integer browser = 0;
	private Integer messagingUnknown = 0;
	private Integer measurement = 0;
	private Integer video = 0;
	private Integer cellModem = 0;
	private Integer satellite = 0;
	private Integer digitalImageCapture = 0;
	
	private String facility = null;
	private String visnName = null;
	private String vendorName = null;

	public Integer getVisnId() {
	
		return visnId;
	}

	public void setVisnId(Integer visnId) {
		this.visnId = visnId;
	}

	public Integer getPatientTotals() {	
		
		return patientTotals;
	}

	public void setPatientTotals(Integer patientTotals) {
		
		if(patientTotals != null)
		{
			this.patientTotals = patientTotals;
		}
		else
		{
			patientTotals = 0;
		}
	}

	public Integer getDialogue() {
		return dialogue;
	}

	public void setDialogue(Integer dialogue) {

		if(dialogue != null)
		{
			this.dialogue = dialogue;
		}
		else
		{
			dialogue = 0;
		}
	}

	public Integer getMessagingByDevice() {
		return messagingByDevice;
	}

	public void setMessagingByDevice(Integer messagingByDevice) {

		if(messagingByDevice != null)
		{
			this.messagingByDevice = messagingByDevice;
		}
		else
		{
			messagingByDevice = 0;
		}
	}

	public Integer getMessagingByIVR() {
		return messagingByIVR;
	}

	public void setMessagingByIVR(Integer messagingByIVR) {

		if(messagingByIVR != null)
		{
			this.messagingByIVR = messagingByIVR;
		}
		else
		{
			messagingByIVR = 0;
		}
	}

	public Integer getBrowser() {
		return browser;
	}

	public void setBrowser(Integer browser) {

		if(browser != null)
		{
			this.browser = browser;
		}
		else
		{
			browser = 0;
		}
	}

	public Integer getMessagingUnknown() {
		return messagingUnknown;
	}

	public void setMessagingUnknown(Integer messagingUnknown) {
		if(messagingUnknown != null)
		{
			this.messagingUnknown = messagingUnknown;
		}
		else
		{
			messagingUnknown = 0;
		}
		
	}

	public Integer getMeasurement() {
		return measurement;
	}

	public void setMeasurement(Integer measurement) {

		if(measurement != null)
		{
			this.measurement = measurement;
		}
		else
		{
			measurement = 0;
		}
	}

	public Integer getVideo() {
		return video;
	}

	public void setVideo(Integer video) {

		if(video != null)
		{
			this.video = video;
		}
		else
		{
			video = 0;
		}
	}

	public Integer getCellModem() {
		return cellModem;
	}

	public void setCellModem(Integer cellModem) {

		if(cellModem != null)
		{
			this.cellModem = cellModem;
		}
		else
		{
			cellModem = 0;
		}
	}

	public Integer getSatellite() {
		return satellite;
	}

	public void setSatellite(Integer satellite) {

		if(satellite != null)
		{
			this.satellite = satellite;
		}
		else
		{
			satellite = 0;
		}
	}

	public Integer getDigitalImageCapture() {
		return digitalImageCapture;
	}

	public void setDigitalImageCapture(Integer digitalImageCapture) {

		if(digitalImageCapture != null)
		{
			this.digitalImageCapture = digitalImageCapture;
		}
		else
		{
			digitalImageCapture = 0;
		}
	}
	
	public String getFacility()
	{
		return facility;
	}
	
	public void setFacility(String facility)
	{
		this.facility = facility;
	}

	public String getVisnName() {
		return visnName;
	}

	public void setVisnName(String visnName) {
		this.visnName = visnName;
	}	
	
	public String getVendorName() {
		return vendorName;
	}

	public void setVendorName(String vendorName) {
		this.vendorName = vendorName;
	}

	
	
	
	public void add(CensusActivityVisnRecord recordToAdd)
	{
		patientTotals += recordToAdd.getPatientTotals();
		dialogue += recordToAdd.getDialogue();
		messagingByDevice += recordToAdd.getMessagingByDevice();
		messagingByIVR += recordToAdd.getMessagingByIVR();
		browser += recordToAdd.getBrowser();
		messagingUnknown += recordToAdd.getMessagingUnknown();
		measurement += recordToAdd.getMeasurement();
		video += recordToAdd.getVideo();
		cellModem += recordToAdd.getCellModem();
		satellite += recordToAdd.getSatellite();
		digitalImageCapture += recordToAdd.getDigitalImageCapture();
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((browser == null) ? 0 : browser.hashCode());
		result = prime * result
				+ ((cellModem == null) ? 0 : cellModem.hashCode());
		result = prime * result
				+ ((dialogue == null) ? 0 : dialogue.hashCode());
		result = prime
				* result
				+ ((digitalImageCapture == null) ? 0 : digitalImageCapture
						.hashCode());
		result = prime * result
				+ ((facility == null) ? 0 : facility.hashCode());
		result = prime * result
				+ ((measurement == null) ? 0 : measurement.hashCode());
		result = prime
				* result
				+ ((messagingByDevice == null) ? 0 : messagingByDevice
						.hashCode());
		result = prime * result
				+ ((messagingByIVR == null) ? 0 : messagingByIVR.hashCode());
		result = prime
				* result
				+ ((messagingUnknown == null) ? 0 : messagingUnknown.hashCode());
		result = prime * result
				+ ((patientTotals == null) ? 0 : patientTotals.hashCode());
		result = prime * result
				+ ((satellite == null) ? 0 : satellite.hashCode());
		result = prime * result
				+ ((vendorName == null) ? 0 : vendorName.hashCode());
		result = prime * result + ((video == null) ? 0 : video.hashCode());
		result = prime * result + ((visnId == null) ? 0 : visnId.hashCode());
		result = prime * result
				+ ((visnName == null) ? 0 : visnName.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		CensusActivityVisnRecord other = (CensusActivityVisnRecord) obj;
		if (browser == null) {
			if (other.browser != null)
				return false;
		} else if (!browser.equals(other.browser))
			return false;
		if (cellModem == null) {
			if (other.cellModem != null)
				return false;
		} else if (!cellModem.equals(other.cellModem))
			return false;
		if (dialogue == null) {
			if (other.dialogue != null)
				return false;
		} else if (!dialogue.equals(other.dialogue))
			return false;
		if (digitalImageCapture == null) {
			if (other.digitalImageCapture != null)
				return false;
		} else if (!digitalImageCapture.equals(other.digitalImageCapture))
			return false;
		if (facility == null) {
			if (other.facility != null)
				return false;
		} else if (!facility.equals(other.facility))
			return false;
		if (measurement == null) {
			if (other.measurement != null)
				return false;
		} else if (!measurement.equals(other.measurement))
			return false;
		if (messagingByDevice == null) {
			if (other.messagingByDevice != null)
				return false;
		} else if (!messagingByDevice.equals(other.messagingByDevice))
			return false;
		if (messagingByIVR == null) {
			if (other.messagingByIVR != null)
				return false;
		} else if (!messagingByIVR.equals(other.messagingByIVR))
			return false;
		if (messagingUnknown == null) {
			if (other.messagingUnknown != null)
				return false;
		} else if (!messagingUnknown.equals(other.messagingUnknown))
			return false;
		if (patientTotals == null) {
			if (other.patientTotals != null)
				return false;
		} else if (!patientTotals.equals(other.patientTotals))
			return false;
		if (satellite == null) {
			if (other.satellite != null)
				return false;
		} else if (!satellite.equals(other.satellite))
			return false;
		if (vendorName == null) {
			if (other.vendorName != null)
				return false;
		} else if (!vendorName.equals(other.vendorName))
			return false;
		if (video == null) {
			if (other.video != null)
				return false;
		} else if (!video.equals(other.video))
			return false;
		if (visnId == null) {
			if (other.visnId != null)
				return false;
		} else if (!visnId.equals(other.visnId))
			return false;
		if (visnName == null) {
			if (other.visnName != null)
				return false;
		} else if (!visnName.equals(other.visnName))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "CensusActivityVisnRecord [browser=" + browser + ", cellModem="
				+ cellModem + ", dialogue=" + dialogue
				+ ", digitalImageCapture=" + digitalImageCapture
				+ ", facility=" + facility + ", measurement=" + measurement
				+ ", messagingByDevice=" + messagingByDevice
				+ ", messagingByIVR=" + messagingByIVR + ", messagingUnknown="
				+ messagingUnknown + ", patientTotals=" + patientTotals
				+ ", satellite=" + satellite + ", vendorName=" + vendorName
				+ ", video=" + video + ", visnId=" + visnId + ", visnName="
				+ visnName + "]";
	}

	


}
