package gov.va.med.ccht.model.coc;

import gov.va.med.fw.ui.model.TermType;
import gov.va.med.fw.util.DateUtils;

import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.Date;

public class CategoryOfCareReportParameters implements Serializable 
{
    
    private static final long serialVersionUID = -4558459399794705023L;
    private Date reportStartDate = null;
    private Date weekEndingDate = null;
    private TermType vendor;
    
    public String getReportStartDateAsString()
    {
	SimpleDateFormat format = new SimpleDateFormat(DateUtils.MMDDYYYY);
	return format.format(reportStartDate);	
    }
    
    public Date getReportStartDate()
    {	
        return reportStartDate;
    }
    public void setReportStartDate(Date aDate)
    {	
        this.reportStartDate = aDate;
    }
    
    public Date getWeekEndingDate()
    {
        return weekEndingDate;
    }
    public void setWeekEndingDate(Date weekEndingDate)
    {
        this.weekEndingDate = weekEndingDate;
    }

    public TermType getVendor()
    {
        return vendor;
    }

    public void setVendor(TermType vendor)
    {
        this.vendor = vendor;
    }

    @Override
    public int hashCode()
    {
	final int prime = 31;
	int result = 1;
	result = prime * result + ((reportStartDate == null) ? 0 : reportStartDate.hashCode());
	result = prime * result + ((vendor == null) ? 0 : vendor.hashCode());
	result = prime * result + ((weekEndingDate == null) ? 0 : weekEndingDate.hashCode());
	return result;
    }

    @Override
    public boolean equals(Object obj)
    {
	if (this == obj) return true;
	if (obj == null) return false;
	if (getClass() != obj.getClass()) return false;
	CategoryOfCareReportParameters other = (CategoryOfCareReportParameters) obj;
	if (reportStartDate == null)
	{
	    if (other.reportStartDate != null) return false;
	}
	else if (!reportStartDate.equals(other.reportStartDate)) return false;
	if (vendor == null)
	{
	    if (other.vendor != null) return false;
	}
	else if (!vendor.equals(other.vendor)) return false;
	if (weekEndingDate == null)
	{
	    if (other.weekEndingDate != null) return false;
	}
	else if (!weekEndingDate.equals(other.weekEndingDate)) return false;
	return true;
    }

    @Override
    public String toString()
    {
	return "CategoryOfCareReportParameters [reportStartDate=" + reportStartDate + ", vendor=" + vendor
		+ ", weekEndingDate=" + weekEndingDate + "]";
    }

}
