package gov.va.med.ccht.model.coc;

import java.io.Serializable;

public class CategoryOfCareRow implements Serializable
{
    private static final long serialVersionUID = 2675745099952039586L;
    
    private String columnZero = "0";	// Vendor name
    private String columnOne = "0";	// NIC
    private String columnTwo = "0";	// Chronic Care
    private String columnThree = "0";	// Acute Care
    private String columnFour = "0";	// Health Promo
    private String columnFive = "0";	//  Low Acuity
    private String columnSix = "0";	// Totals By Vendor
    
    private String vendorName = "";
    private Integer nicTotal = 0;
    private Integer chronicCareTotal = 0;
    private Integer acuteCareTotal = 0;
    private Integer healthPromoTotal = 0;
    private Integer lowAcuityTotal = 0;
    private Integer totalByVendor = 0;
     
    
    public String getColumnZero()
    {
        return columnZero;
    }
    public void setColumnZero(String columnZero)
    {
        this.columnZero = columnZero;
    }
    public String getColumnOne()
    {
        return columnOne;
    }
    public void setColumnOne(String columnOne)
    {
        this.columnOne = columnOne;
    }
    public String getColumnTwo()
    {
        return columnTwo;
    }
    public void setColumnTwo(String columnTwo)
    {
        this.columnTwo = columnTwo;
    }
    public String getColumnThree()
    {
        return columnThree;
    }
    public void setColumnThree(String columnThree)
    {
        this.columnThree = columnThree;
    }
    public String getColumnFour()
    {
        return columnFour;
    }
    public void setColumnFour(String columnFour)
    {
        this.columnFour = columnFour;
    }
    public String getColumnFive()
    {
        return columnFive;
    }
    public void setColumnFive(String columnFive)
    {
        this.columnFive = columnFive;
    }
    public String getColumnSix()
    {
        return columnSix;
    }
    public void setColumnSix(String columnSix)
    {
        this.columnSix = columnSix;
    }
    
    public String getVendorName()
    {
        return vendorName;
    }
    public void setVendorName(String vendorName)
    {
        this.vendorName = vendorName;
        columnZero = vendorName;
    }

    public Integer getNicTotal()
    {
        return nicTotal;
    }
    public void setNicTotal(Integer nicTotal)
    {
        this.nicTotal = nicTotal;
        columnOne = nicTotal.toString();
    }
    
    public Integer getChronicCareTotal()
    {
        return chronicCareTotal;
    }
    public void setChronicCareTotal(Integer chronicCareTotal)
    {
        this.chronicCareTotal = chronicCareTotal;
        columnTwo = chronicCareTotal.toString();
    }
    
    public Integer getAcuteCareTotal()
    {
        return acuteCareTotal;
    }
    public void setAcuteCareTotal(Integer acuteCareTotal)
    {
        this.acuteCareTotal = acuteCareTotal;
        columnThree = acuteCareTotal.toString();
    }
    
    public Integer getHealthPromoTotal()
    {
        return healthPromoTotal;
    }
    public void setHealthPromoTotal(Integer healthPromoTotal)
    {
        this.healthPromoTotal = healthPromoTotal;
        columnFour = healthPromoTotal.toString();
    }
    
    public Integer getLowAcuityTotal()
    {
        return lowAcuityTotal;
    }
    public void setLowAcuityTotal(Integer lowAcuityTotal)
    {
        this.lowAcuityTotal = lowAcuityTotal;
        columnFive = lowAcuityTotal.toString();
    }
    
    public Integer getTotalByVendor()
    {
        return totalByVendor;
    }
    public void setTotalByVendor(Integer totalByVendor)
    {
        this.totalByVendor = totalByVendor;
    }
    
    public void setTotalsByVendor()
    {
	totalByVendor = nicTotal + chronicCareTotal + acuteCareTotal + healthPromoTotal;
	columnSix = totalByVendor.toString();
    }
    @Override
    public int hashCode()
    {
	final int prime = 31;
	int result = 1;
	result = prime * result + ((acuteCareTotal == null) ? 0 : acuteCareTotal.hashCode());
	result = prime * result + ((columnTwo == null) ? 0 : columnTwo.hashCode());
	result = prime * result + ((chronicCareTotal == null) ? 0 : chronicCareTotal.hashCode());
	result = prime * result + ((columnOne == null) ? 0 : columnOne.hashCode());
	result = prime * result + ((healthPromoTotal == null) ? 0 : healthPromoTotal.hashCode());
	result = prime * result + ((columnThree == null) ? 0 : columnThree.hashCode());
	result = prime * result + ((lowAcuityTotal == null) ? 0 : lowAcuityTotal.hashCode());
	result = prime * result + ((columnFour == null) ? 0 : columnFour.hashCode());
	result = prime * result + ((nicTotal == null) ? 0 : nicTotal.hashCode());
	result = prime * result + ((columnZero == null) ? 0 : columnZero.hashCode());
	result = prime * result + ((totalByVendor == null) ? 0 : totalByVendor.hashCode());
	result = prime * result + ((columnFive == null) ? 0 : columnFive.hashCode());
	return result;
    }
    
    @Override
    public boolean equals(Object obj)
    {
	if (this == obj) return true;
	if (obj == null) return false;
	if (getClass() != obj.getClass()) return false;
	CategoryOfCareRow other = (CategoryOfCareRow) obj;
	if (acuteCareTotal == null)
	{
	    if (other.acuteCareTotal != null) return false;
	}
	else if (!acuteCareTotal.equals(other.acuteCareTotal)) return false;
	if (columnTwo == null)
	{
	    if (other.columnTwo != null) return false;
	}
	else if (!columnTwo.equals(other.columnTwo)) return false;
	if (chronicCareTotal == null)
	{
	    if (other.chronicCareTotal != null) return false;
	}
	else if (!chronicCareTotal.equals(other.chronicCareTotal)) return false;
	if (columnOne == null)
	{
	    if (other.columnOne != null) return false;
	}
	else if (!columnOne.equals(other.columnOne)) return false;
	if (healthPromoTotal == null)
	{
	    if (other.healthPromoTotal != null) return false;
	}
	else if (!healthPromoTotal.equals(other.healthPromoTotal)) return false;
	if (columnThree == null)
	{
	    if (other.columnThree != null) return false;
	}
	else if (!columnThree.equals(other.columnThree)) return false;
	if (lowAcuityTotal == null)
	{
	    if (other.lowAcuityTotal != null) return false;
	}
	else if (!lowAcuityTotal.equals(other.lowAcuityTotal)) return false;
	if (columnFour == null)
	{
	    if (other.columnFour != null) return false;
	}
	else if (!columnFour.equals(other.columnFour)) return false;
	if (nicTotal == null)
	{
	    if (other.nicTotal != null) return false;
	}
	else if (!nicTotal.equals(other.nicTotal)) return false;
	if (columnZero == null)
	{
	    if (other.columnZero != null) return false;
	}
	else if (!columnZero.equals(other.columnZero)) return false;
	if (totalByVendor == null)
	{
	    if (other.totalByVendor != null) return false;
	}
	else if (!totalByVendor.equals(other.totalByVendor)) return false;
	if (columnFive == null)
	{
	    if (other.columnFive != null) return false;
	}
	else if (!columnFive.equals(other.columnFive)) return false;
	return true;
    }
    
    @Override
    public String toString()
    {	
	return "CategoryOfCareRow [vendorName = " + vendorName + " acuteCareTotal=" + acuteCareTotal + ", acuteCareTotalAsString="
		+ columnTwo + ", chronicCareTotal=" + chronicCareTotal + ", chronicCareTotalAsString="
		+ columnOne + ", healthPromoTotal=" + healthPromoTotal + ", healthPromoTotalAsString="
		+ columnThree + ", lowAcuityTotal=" + lowAcuityTotal + ", lowAcuityTotalAsString="
		+ columnFour + ", nicTotal=" + nicTotal + ", nicTotalAsString=" + columnZero
		+ ", totalByVendor=" + totalByVendor + ", totalByVendorAsString=" + columnFive + "]";
    }    

}
