/**
 * 
 */
package gov.va.med.ccht.model.qir;

import javax.persistence.Transient;

import gov.va.med.fw.model.lookup.AbstractLookup;

/**
 * @author DNS   katikm
 *
 */
public class QIRStatusType extends AbstractLookup {

	private static final long serialVersionUID = -6544766354601437705L;
	
	public static final String NEW = "1";
	public static final String APPROVED = "2";
	public static final String WITHDRAWN = "3";
	public static final String REPLIED = "4";
	public static final String AGREED = "5";
	public static final String CLOSED = "6";
	
	@Transient
	public boolean isNew() {
		return getCode().equals(NEW);
	}

	@Transient
	public boolean isApproved() {
		return getCode().equals(APPROVED);
	}

	@Transient
	public boolean isWithdrawn() {
		return getCode().equals(WITHDRAWN);
	}

	@Transient
	public boolean isReplied() {
		return getCode().equals(REPLIED);
	}

	@Transient
	public boolean isAgreed() {
		return getCode().equals(AGREED);
	}

	@Transient
	public boolean isClosed() {
		return getCode().equals(CLOSED);
	}
	
}
