package gov.va.med.ccht.persistent;

import gov.va.med.ccht.model.dmp.PatientSatSurveyReportParameters;
import gov.va.med.ccht.model.dmpreport.PSSQuestionManager;
import gov.va.med.ccht.model.dmpreport.SatisfactionSurveyQuestionResult;
import gov.va.med.ccht.model.dmpreport.SatisfactionSurveyTrendEntry;
import gov.va.med.ccht.model.dmpreport.SurveyDistributionEntry;
import gov.va.med.ccht.model.dmpreport.SurveyDistributionSearchResult;
import gov.va.med.ccht.model.dmpreport.VRTwelveReportResults;
import gov.va.med.ccht.model.dmpreport.VendorSubmissionReportEntry;
import gov.va.med.fw.persistent.DAOException;
import gov.va.med.fw.persistent.DAOOperations;

import java.util.List;

public interface PSSReportsDAO  extends DAOOperations 
{
	public List<VRTwelveReportResults> getVRTwelveReport(PatientSatSurveyReportParameters reportParams) throws DAOException;
	//public List<SatisfactionSurveyQuestionResult> getSatisfactionSurveyReport(PatientSatSurveyReportParameters reportParams) throws DAOException;
	//public SurveyDistributionSearchResult getSurveyDistributionReport(PatientSatSurveyReportParameters reportParams) throws DAOException;
	public List<SatisfactionSurveyTrendEntry> getSatisfactionSurveyTrendReport(PatientSatSurveyReportParameters reportParams) throws DAOException;
	public List<VendorSubmissionReportEntry> getVendorSubmissionReport(PatientSatSurveyReportParameters reportParams) throws DAOException;
	public PSSQuestionManager getQuestionsForReportVersion(Integer version) throws DAOException;
}
