package gov.va.med.ccht.persistent.hibernate;


import gov.va.med.ccht.model.car.CensusActivityModalityRecord;
import gov.va.med.ccht.model.car.CensusActivityReportParameters;
import gov.va.med.ccht.persistent.CensusActivityReportModalityDAO;
import gov.va.med.fw.persistent.DAOException;
import gov.va.med.fw.persistent.hibernate.GenericDAOImpl;
import gov.va.med.fw.persistent.hibernate.QueryAndParams;
import gov.va.med.fw.ui.model.TermType;

import java.util.ArrayList;
import java.util.List;

public class CensusActivityReportModalityDAOImpl extends GenericDAOImpl implements
		CensusActivityReportModalityDAO {
	

	public List<CensusActivityModalityRecord> getSingleModalityAllVendorAllVisnReport(CensusActivityReportParameters reportParams) throws DAOException
	{
		List<CensusActivityModalityRecord> retVal = new ArrayList<CensusActivityModalityRecord>();
		QueryAndParams queryAndParams = new QueryAndParams();
		String selectedModality = reportParams.getColumnNameForModality();
		
		TermType selectedVisnTermType = reportParams.getVisn();
		String selectedVisn = selectedVisnTermType.getValue();
		String sql = null;
		sql = getSingleModalityAllVendorsSQL(selectedModality);	
		
		
		
		String reportWeek = reportParams.getReportDate();
		
		queryAndParams.addParam("reportWeek", reportWeek);
		queryAndParams.append(sql);
		

		List<?> report = executeSQLQuery(queryAndParams);
		int numIterations = report.size();
		CensusActivityModalityRecord totalRecord = new CensusActivityModalityRecord();
		totalRecord.setSelectedModalityName(selectedModality);
		for (int j = 0; j < numIterations; j++) {
			Object[] record = (Object[]) report.get(j);
			CensusActivityModalityRecord tempRecord = new CensusActivityModalityRecord();

			// Set the current record
			int visnId = getIntFromDBCol(record[0]);
			int patientTotal = getIntFromDBCol(record[1]);
			int selectedModalityTotal = getIntFromDBCol(record[2]);
			tempRecord.setVisnId(visnId);
			tempRecord.setVisnName(visnId);
			tempRecord.setPatientTotals(patientTotal);
			tempRecord.setSelectedModalityTotal(selectedModalityTotal);
			tempRecord.setSelectedModalityName(selectedModality);

			// Add the values of the current record to a
			// record that will represent a totals row
			totalRecord.add(tempRecord);

			retVal.add(tempRecord);
		}

		retVal.add(totalRecord);

		return retVal;
	}	
	
	
	public List<CensusActivityModalityRecord> getSingleModalitySubtotaledVisnReport(CensusActivityReportParameters reportParams) throws DAOException
	{
		List<CensusActivityModalityRecord> retVal = new ArrayList<CensusActivityModalityRecord>();
		String selectedModality = reportParams.getColumnNameForModality();
		String sql = getSingleModalityWithVendorsSubtotaledSQL(selectedModality);
		String weekEndingDate = reportParams.getReportDate();
		QueryAndParams queryAndParams = new QueryAndParams();
		queryAndParams.addParam("reportWeek", weekEndingDate);
		queryAndParams.append(sql);
		

		List<?> report = executeSQLQuery(queryAndParams);
		int numIterations = report.size();
		CensusActivityModalityRecord totalRecord = new CensusActivityModalityRecord();
		totalRecord.setVisnName("Total");
		for (int j = 0; j < numIterations; j++) {
			Object[] record = (Object[]) report.get(j);
			CensusActivityModalityRecord tempRecord = new CensusActivityModalityRecord();

			

			// Add the values of the current record to a
			// record that will represent a totals row
			int visnId = getIntFromDBCol(record[0]);
			int patientTotals = getIntFromDBCol(record[2]);
			int selectedModalityTotal = getIntFromDBCol(record[3]);
			tempRecord.setVisnId(visnId);
			tempRecord.setVisnName(visnId);
			tempRecord.setVendor((String)record[1]);
			tempRecord.setPatientTotals(patientTotals);
			tempRecord.setSelectedModalityTotal(selectedModalityTotal);
			
			tempRecord.setSelectedModalityName(selectedModality);

			totalRecord.add(tempRecord);
			retVal.add(tempRecord);
		}

		retVal.add(totalRecord);
		
		return retVal;
	}
	
	
	
	public List<CensusActivityModalityRecord> getSingleVisnSingleModalityAllVendorVisnReport(CensusActivityReportParameters reportParams) throws DAOException
	{
		List<CensusActivityModalityRecord> retVal = new ArrayList<CensusActivityModalityRecord>();
		QueryAndParams queryAndParams = new QueryAndParams();
		String selectedModality = reportParams.getColumnNameForModality();
		
		TermType selectedVisnTermType = reportParams.getVisn();
		String selectedVisn = selectedVisnTermType.getValue();
		String sql = null;
		
		sql = getSingleVisnSingleModalityAllVendorsSQL(selectedModality);	
		String reportWeek = reportParams.getReportDate();
		queryAndParams.addParam("visnId", selectedVisn);
		queryAndParams.addParam("reportWeek", reportWeek);
		queryAndParams.append(sql);
		

		List<?> report = executeSQLQuery(queryAndParams);
		int numIterations = report.size();
		CensusActivityModalityRecord totalRecord = new CensusActivityModalityRecord();
		totalRecord.setSelectedModalityName(selectedModality);
		for (int j = 0; j < numIterations; j++) {
			Object[] record = (Object[]) report.get(j);
			CensusActivityModalityRecord tempRecord = new CensusActivityModalityRecord();

			// Set the current record
			int visnId = getIntFromDBCol(record[0]);
			int patientTotal = getIntFromDBCol(record[1]);
			int selectedModalityTotal = getIntFromDBCol(record[2]);
			tempRecord.setVisnId(visnId);
			tempRecord.setVisnName(visnId);
			tempRecord.setPatientTotals(patientTotal);
			tempRecord.setSelectedModalityTotal(selectedModalityTotal);
			tempRecord.setSelectedModalityName(selectedModality);

			// Add the values of the current record to a
			// record that will represent a totals row
			totalRecord.add(tempRecord);

			retVal.add(tempRecord);
		}

		retVal.add(totalRecord);

		return retVal;
	}
	
	public List<CensusActivityModalityRecord> getSingleVisnSingleModalitySingleVendorReport(CensusActivityReportParameters reportParams) throws DAOException
	{
		List<CensusActivityModalityRecord> retVal = new ArrayList<CensusActivityModalityRecord>();
		QueryAndParams queryAndParams = new QueryAndParams();
		String selectedModality = reportParams.getColumnNameForModality();
		
		TermType selectedVisnTermType = reportParams.getVisn();
		String selectedVisn = selectedVisnTermType.getValue();
		
		TermType selectedVendorTermType = reportParams.getVendor();
		String selectedVendor = selectedVendorTermType.getValue();
		
		String sql = null;
		
		sql = getSingleVisnSingleModalitySingleVendorsSQL(selectedModality);	
		String reportWeek = reportParams.getReportDate();
		queryAndParams.addParam("visnId", selectedVisn);
		queryAndParams.addParam("reportWeek", reportWeek);
		queryAndParams.addParam("vendorId", selectedVendor);
		queryAndParams.append(sql);
		

		List<?> report = executeSQLQuery(queryAndParams);
		int numIterations = report.size();
		CensusActivityModalityRecord totalRecord = new CensusActivityModalityRecord();
		totalRecord.setSelectedModalityName(selectedModality);
		for (int j = 0; j < numIterations; j++) {
			Object[] record = (Object[]) report.get(j);
			CensusActivityModalityRecord tempRecord = new CensusActivityModalityRecord();

			// Set the current record
			int visnId = getIntFromDBCol(record[0]);
			int patientTotal = getIntFromDBCol(record[1]);
			int selectedModalityTotal = getIntFromDBCol(record[2]);
			tempRecord.setVisnId(visnId);
			tempRecord.setVisnName(visnId);
			tempRecord.setPatientTotals(patientTotal);
			tempRecord.setSelectedModalityTotal(selectedModalityTotal);
			tempRecord.setSelectedModalityName(selectedModality);

			// Add the values of the current record to a
			// record that will represent a totals row
			totalRecord.add(tempRecord);

			retVal.add(tempRecord);
		}

		retVal.add(totalRecord);

		return retVal;
	}
	
	
	public List<CensusActivityModalityRecord> getSingleVisnSingleModalitySubtotaledVisnReport(CensusActivityReportParameters reportParams) throws DAOException
	{
		List<CensusActivityModalityRecord> retVal = new ArrayList<CensusActivityModalityRecord>();
		String selectedModality = reportParams.getColumnNameForModality();
		String sql = getSingleVisnSingleModalityWithVendorsSubtotaledSQL(selectedModality);
		String weekEndingDate = reportParams.getReportDate();
		
		TermType selectedVisnTermType = reportParams.getVisn();
		String selectedVisn = selectedVisnTermType.getValue();
		
		QueryAndParams queryAndParams = new QueryAndParams();
		queryAndParams.addParam("reportWeek", weekEndingDate);
		queryAndParams.addParam("visnId", selectedVisn);
		queryAndParams.append(sql);
		

		List<?> report = executeSQLQuery(queryAndParams);
		int numIterations = report.size();
		CensusActivityModalityRecord totalRecord = new CensusActivityModalityRecord();
		totalRecord.setVisnName("Total");
		for (int j = 0; j < numIterations; j++) {
			Object[] record = (Object[]) report.get(j);
			CensusActivityModalityRecord tempRecord = new CensusActivityModalityRecord();

			

			// Add the values of the current record to a
			// record that will represent a totals row
			int visnId = getIntFromDBCol(record[0]);
			int patientTotals = getIntFromDBCol(record[2]);
			int selectedModalityTotal = getIntFromDBCol(record[3]);
			tempRecord.setVisnId(visnId);
			tempRecord.setVisnName(visnId);
			tempRecord.setVendor((String)record[1]);
			tempRecord.setPatientTotals(patientTotals);
			tempRecord.setSelectedModalityTotal(selectedModalityTotal);
			
			tempRecord.setSelectedModalityName(selectedModality);

			totalRecord.add(tempRecord);
			retVal.add(tempRecord);
		}

		retVal.add(totalRecord);
		
		return retVal;
	}

	public List<CensusActivityModalityRecord> getSingleModalitySingleVendorVisnReport(CensusActivityReportParameters reportParams) throws DAOException
	{
		List<CensusActivityModalityRecord> retVal = new ArrayList<CensusActivityModalityRecord>();
		String selectedModality = reportParams.getColumnNameForModality();
		String sql = getSingleModalitySingleVendorSQL(selectedModality);
		String weekEndingDate = reportParams.getReportDate();
		String vendorId = reportParams.getVendor().getValue();
		QueryAndParams queryAndParams = new QueryAndParams();
		queryAndParams.addParam("reportWeek", weekEndingDate);
		queryAndParams.addParam("vendorId", vendorId);
		queryAndParams.append(sql);
		

		List<?> report = executeSQLQuery(queryAndParams);
		int numIterations = report.size();
		CensusActivityModalityRecord totalRecord = new CensusActivityModalityRecord();
		totalRecord.setVisnName("Total");
		for (int j = 0; j < numIterations; j++) {
			Object[] record = (Object[]) report.get(j);
			CensusActivityModalityRecord tempRecord = new CensusActivityModalityRecord();
			
			// Set the current record
			int visnId = getIntFromDBCol( record[0]);
			int patientTotals = getIntFromDBCol( record[1]);
			int selectedModalityTotal = getIntFromDBCol( record[2]);
			tempRecord.setVisnId(visnId);
			tempRecord.setVisnName(visnId);
			tempRecord.setPatientTotals(patientTotals);
			tempRecord.setSelectedModalityTotal(selectedModalityTotal);
			tempRecord.setSelectedModalityName(selectedModality);

			// Add the values of the current record to a
			// record that will represent a totals row
			totalRecord.add(tempRecord);

		

			retVal.add(tempRecord);
		}

		retVal.add(totalRecord);
		return retVal;
	}
	
	
	public List<CensusActivityModalityRecord> getFacilityDrilldownData(CensusActivityReportParameters params) throws DAOException
	{
		List<CensusActivityModalityRecord> retVal = new ArrayList<CensusActivityModalityRecord>();
		QueryAndParams queryAndParams = new QueryAndParams();
		String selectedModality = params.getColumnNameForModality();
		String reportWeek = params.getReportDate();
		String selectedVisnId = params.getVisn().getValue();
		String selectedVendorId = params.getVendor().getValue();
		
		
		String sql = null;
		
		
		if(selectedVendorId.equalsIgnoreCase("All Vendors"))
		{
			sql = getFacilityDrillDownSQL(selectedModality);
			queryAndParams.append(sql);
		}
		else
		{
			sql = getFacilityDrillDownSingleVendorSQL(selectedModality);
			queryAndParams.append(sql);			
			queryAndParams.addParam("vendorId", selectedVendorId);
		}
		queryAndParams.addParam("reportWeek", reportWeek);
		queryAndParams.addParam("visnId", selectedVisnId);
	
		List<?> rows = executeSQLQuery(queryAndParams);
		
		int numRows = rows.size();
		CensusActivityModalityRecord totalRecord = new CensusActivityModalityRecord();
		totalRecord.setFacility("Totals");
		
		for (int j = 0; j < numRows; j++) 
		{
			Object[] record = (Object[]) rows.get(j);
			CensusActivityModalityRecord temp = new CensusActivityModalityRecord();
		
			String facility = (String)record[0];
			int visnId = getIntFromDBCol(record[1]);
			int totalPatientCount = getIntFromDBCol(record[2]);
			int selectedModalityCount = getIntFromDBCol(record[3]);
			String visnName = "VISN " + visnId;
			
			
			temp.setFacility(facility);
			temp.setVisnId(visnId);
			temp.setPatientTotals(totalPatientCount);
			temp.setSelectedModalityTotal(selectedModalityCount);
			temp.setVisnName(visnName);
			totalRecord.add(temp);
			retVal.add(temp);
		}
		retVal.add(totalRecord);
		return retVal;
	}
	
	
	private Integer getIntFromDBCol(Object col)
	{
		Integer retVal = 0;
		
		if(col != null)
		{
			retVal = (Integer)col;
		}
		
		
		return retVal;
		
	}
	
	private String getSingleModalityAllVendorsSQL(String chosenModality)
	{
		/*
		 * select VISN.VISN_ID, 
		 * sum(Facility_Activity.Patient_Totals) AS [Patient_Totals], 
		 * sum(Facility_Activity.Dialogue) AS [Dialogue] 
		 * from Facilities, Facility_Activity, VISN 
		 * where Facility_Activity.Facility_ID=Facilities.ID and 
		 * Facility_Activity.Rpt_Wk='2015-01-24' and 
		 * Facilities.VISN_ID=VISN.VISN_ID 
		 * group by VISN.VISN_ID  order by 1 ASC
		 */
		StringBuilder sb = new StringBuilder();
		
		sb.append("select VISN.VISN_ID, ");
		sb.append("sum(Facility_Activity.Patient_Totals) AS [Patient_Totals], ");
		sb.append("sum(Facility_Activity."); 
		sb.append(chosenModality);
		sb.append(") AS Modality ");
		sb.append("from Facilities, Facility_Activity, VISN ");
		sb.append("where Facility_Activity.Facility_ID=Facilities.ID and ");
		sb.append("Facility_Activity.Rpt_Wk=:reportWeek and ");
		sb.append("Facilities.VISN_ID=VISN.VISN_ID ");
		sb.append("group by VISN.VISN_ID  order by 1 ASC ");
		
		return sb.toString();
	}
	
	private String getSingleVisnSingleModalityAllVendorsSQL(String chosenModality)
	{
		/*
		 * select VISN.VISN_ID, 
		 * sum(Facility_Activity.Patient_Totals) AS [Patient_Totals], 
		 * sum(Facility_Activity.Dialogue) AS [Dialogue] 
		 * from Facilities, Facility_Activity, VISN 
		 * where Facility_Activity.Facility_ID=Facilities.ID and 
		 * Facility_Activity.Rpt_Wk='2015-01-24' and 
		 * Facilities.VISN_ID=VISN.VISN_ID 
		 * group by VISN.VISN_ID  order by 1 ASC
		 */
		StringBuilder sb = new StringBuilder();
		
		sb.append("select VISN.VISN_ID, ");
		sb.append("sum(Facility_Activity.Patient_Totals) AS [Patient_Totals], ");
		sb.append("sum(Facility_Activity."); 
		sb.append(chosenModality);
		sb.append(") AS Modality ");
		sb.append("from Facilities, Facility_Activity, VISN ");
		sb.append("where Facility_Activity.Facility_ID=Facilities.ID and ");
		sb.append("Facility_Activity.Rpt_Wk=:reportWeek and ");
		sb.append("VISN.VISN_ID=:visnId and ");
		sb.append("Facilities.VISN_ID=VISN.VISN_ID ");
		sb.append("group by VISN.VISN_ID  order by 1 ASC ");
		
		return sb.toString();
	}
	
	private String getSingleVisnSingleModalitySingleVendorsSQL(String chosenModality)
	{
		/*
		 * REPORT QUERY: 
		 * select VISN.VISN_ID, 
		 * sum(Facility_Activity.Patient_Totals) AS [Patient_Totals], 
		 * sum(Facility_Activity.MessagingByIVR) AS [MessagingByIVR] 
		 * from Facilities, Facility_Activity,Vendor, VISN 
		 * where Facility_Activity.Facility_ID=Facilities.ID and 
		 * Facility_Activity.Rpt_Wk='2015-06-27' and 
		 * Facility_Activity.Vendor_ID=Vendor.Vendor_ID and 
		 * Vendor.Vendor_ID='10' and 
		 * VISN.VISN_ID=1 and 
		 * Facilities.VISN_ID=VISN.VISN_ID 
		 * group by VISN.VISN_ID, Vendor.Vendor_Name  order by 1 ASC
		 */
		StringBuilder sb = new StringBuilder();
		
		sb.append("select VISN.VISN_ID, ");
		sb.append("sum(Facility_Activity.Patient_Totals) AS [Patient_Totals], ");
		sb.append("sum(Facility_Activity."); 
		sb.append(chosenModality);
		sb.append(") AS Modality ");
		sb.append("from Facilities, Facility_Activity, Vendor, VISN ");
		sb.append("where Facility_Activity.Facility_ID=Facilities.ID and ");
		sb.append("Facility_Activity.Rpt_Wk=:reportWeek and ");
		sb.append("Facility_Activity.Vendor_ID=Vendor.Vendor_ID and ");
		sb.append("Vendor.Vendor_ID= :vendorId and  ");
		sb.append("VISN.VISN_ID=:visnId and ");
		sb.append("Facilities.VISN_ID=VISN.VISN_ID ");
		sb.append("group by VISN.VISN_ID  order by 1 ASC ");
		
		return sb.toString();
	}
	

	private String getSingleModalityWithVendorsSubtotaledSQL(String chosenModality)
	{
		/*
		 * select VISN.VISN_ID,Vendor.Vendor_Name, 
		 * sum(Facility_Activity.Patient_Totals) AS [Patient_Totals], 
		 * sum(Facility_Activity.Video) AS [Video] 
		 * from  Facilities 
		 * INNER JOIN Facility_Activity ON Facilities.ID = Facility_Activity.Facility_ID 
		 * INNER JOIN VISN ON Facilities.VISN_ID = VISN.VISN_ID 
		 * INNER JOIN Vendor ON Facility_Activity.Vendor_ID = Vendor.Vendor_ID  
		 * where Facility_Activity.Facility_ID=Facilities.ID and 
		 * Facility_Activity.Rpt_Wk='2015-01-24' and 
		 * Facilities.VISN_ID=VISN.VISN_ID 
		 * group by VISN.VISN_ID, Vendor.Vendor_Name order by 1 ASC
		 */
		StringBuilder sb = new StringBuilder();
		
		sb.append("select VISN.VISN_ID, Vendor.Vendor_Name, ");
		sb.append("sum(Facility_Activity.Patient_Totals) AS [Patient_Totals], ");
		sb.append("sum(Facility_Activity."); 
		sb.append(chosenModality);
		sb.append(") AS Modality ");
		sb.append("from Facilities ");
		sb.append("INNER JOIN Facility_Activity ON Facilities.ID = Facility_Activity.Facility_ID ");
		sb.append("INNER JOIN VISN ON Facilities.VISN_ID = VISN.VISN_ID ");
		sb.append("INNER JOIN Vendor ON Facility_Activity.Vendor_ID = Vendor.Vendor_ID ");
		sb.append("where Facility_Activity.Facility_ID=Facilities.ID and ");
		sb.append("Facility_Activity.Rpt_Wk=:reportWeek and ");
		sb.append("Facilities.VISN_ID=VISN.VISN_ID ");
		sb.append("group by VISN.VISN_ID, Vendor.Vendor_Name order by 1 ASC ");
		
		return sb.toString();
	}
	
	private String getSingleModalitySingleVendorSQL(String chosenModality)
	{
		/*
		 * select VISN.VISN_ID, 
		 * sum(Facility_Activity.Patient_Totals) AS [Patient_Totals], 
		 * sum(Facility_Activity.Video) AS [Video] 
		 * from Facilities, Facility_Activity,Vendor, VISN 
		 * where Facility_Activity.Facility_ID=Facilities.ID and 
		 * Facility_Activity.Rpt_Wk='2015-01-24' and 
		 * Facility_Activity.Vendor_ID=Vendor.Vendor_ID and 
		 * Vendor.Vendor_ID='6' and 
		 * Facilities.VISN_ID=VISN.VISN_ID 
		 * group by VISN.VISN_ID, Vendor.Vendor_Name  order by 1 ASC
		 */
		StringBuilder sb = new StringBuilder();
				 
		sb.append("select VISN.VISN_ID, ");
		sb.append("sum(Facility_Activity.Patient_Totals) AS [Patient_Totals], ");
		sb.append("sum(Facility_Activity."); 
		sb.append(chosenModality);
		sb.append(") AS Modality ");
		sb.append("from Facilities, Facility_Activity, Vendor, VISN ");
		sb.append("where Facility_Activity.Facility_ID=Facilities.ID and ");
		sb.append("Facility_Activity.Rpt_Wk= :reportWeek and ");
		sb.append("Facility_Activity.Vendor_ID=Vendor.Vendor_ID and  ");
		sb.append("Vendor.Vendor_ID= :vendorId and  ");
		sb.append("Facilities.VISN_ID=VISN.VISN_ID ");
		sb.append("group by VISN.VISN_ID, Vendor.Vendor_Name  order by 1 ASC ");
		
		return sb.toString();
	}
	
	
	private String getSingleVisnSingleModalityWithVendorsSubtotaledSQL(String chosenModality)
	{
		/*
		 * select VISN.VISN_ID,Vendor.Vendor_Name, 
		 * sum(Facility_Activity.Patient_Totals) AS [Patient_Totals], 
		 * sum(Facility_Activity.Video) AS [Video] 
		 * from  Facilities 
		 * INNER JOIN Facility_Activity ON Facilities.ID = Facility_Activity.Facility_ID 
		 * INNER JOIN VISN ON Facilities.VISN_ID = VISN.VISN_ID 
		 * INNER JOIN Vendor ON Facility_Activity.Vendor_ID = Vendor.Vendor_ID  
		 * where Facility_Activity.Facility_ID=Facilities.ID and 
		 * Facility_Activity.Rpt_Wk='2015-01-24' and 
		 * Visn.Visn_ID = 1
		 * Facilities.VISN_ID=VISN.VISN_ID 
		 * group by VISN.VISN_ID, Vendor.Vendor_Name order by 1 ASC
		 */
		StringBuilder sb = new StringBuilder();
		
		sb.append("select VISN.VISN_ID, Vendor.Vendor_Name, ");
		sb.append("sum(Facility_Activity.Patient_Totals) AS [Patient_Totals], ");
		sb.append("sum(Facility_Activity."); 
		sb.append(chosenModality);
		sb.append(") AS Modality ");
		sb.append("from Facilities ");
		sb.append("INNER JOIN Facility_Activity ON Facilities.ID = Facility_Activity.Facility_ID ");
		sb.append("INNER JOIN VISN ON Facilities.VISN_ID = VISN.VISN_ID ");
		sb.append("INNER JOIN Vendor ON Facility_Activity.Vendor_ID = Vendor.Vendor_ID ");
		sb.append("where Facility_Activity.Facility_ID=Facilities.ID and ");
		sb.append("Facility_Activity.Rpt_Wk=:reportWeek and ");
		sb.append("VISN.VISN_ID=:visnId and ");
		sb.append("Facilities.VISN_ID=VISN.VISN_ID ");
		sb.append("group by VISN.VISN_ID, Vendor.Vendor_Name order by 1 ASC ");
		
		return sb.toString();
	}
	
	private String getFacilityDrillDownSQL(String selectedModaility)
	{
	
		/*
		 * select CONVERT(VARCHAR(10), Facilities.Facility_ID) + ' - ' +Facilities.Facility_Name AS [Facility],
		 * VISN.VISN_ID AS [VISN], sum(Facility_Activity.Patient_Totals) AS [Total Patients], 
		 * sum(Facility_Activity.Dialogue) AS [Messaging Total] 
		 * from Facilities, Facility_Activity, VISN 
		 * where Facility_Activity.Facility_ID=Facilities.ID 
		 * and Facility_Activity.Rpt_Wk='2015-01-24' 
		 * and VISN.VISN_ID=1 
		 * and Facilities.VISN_ID=VISN.VISN_ID 
		 * group by Facilities.facility_Name,VISN.VISN_ID, Facilities.facility_id 
		 * order by Facilities.Facility_Name DESC
		 */
		StringBuilder sql = new StringBuilder();
		
		sql.append("select CONVERT(VARCHAR(10), Facilities.Facility_ID) + ' - ' +Facilities.Facility_Name AS [Facility], ");
		sql.append("VISN.VISN_ID AS [VISN], sum(Facility_Activity.Patient_Totals) AS [Total Patients], ");
		sql.append("sum(Facility_Activity.");
		sql.append(selectedModaility);
		sql.append(") AS [Modality] ");
		sql.append("from Facilities, Facility_Activity, VISN ");
		sql.append("where Facility_Activity.Facility_ID=Facilities.ID ");
		sql.append("and Facility_Activity.Rpt_Wk= :reportWeek ");
		sql.append("and VISN.VISN_ID= :visnId ");
		sql.append("and Facilities.VISN_ID=VISN.VISN_ID ");
		sql.append("group by Facilities.facility_Name,VISN.VISN_ID, Facilities.facility_id ");
		sql.append("order by Facilities.Facility_Name DESC");
		
		return sql.toString();
	}
	
	
	private String getFacilityDrillDownSingleVendorSQL(String selectedModaility)
	{
	
		/*
		 * 	select CONVERT(VARCHAR(10), Facilities.Facility_ID) + ' - ' +Facilities.Facility_Name AS [Facility], VISN.VISN_ID AS [VISN], 
			sum(Facility_Activity.Patient_Totals) AS [Total Patients], 
			sum(Facility_Activity.MessagingByIVR) AS [Messaging By IVR] 
			from Facilities, Facility_Activity,Vendor, VISN 
			where Facility_Activity.Facility_ID=Facilities.ID and 
			Facility_Activity.Rpt_Wk='2015-06-13' and 
			Facility_Activity.Vendor_ID=Vendor.Vendor_ID and 
			Vendor.Vendor_ID='10' and 
			VISN.VISN_ID=18 and 
			Facilities.VISN_ID=VISN.VISN_ID 
			group by Facilities.facility_Name,VISN.VISN_ID, Facilities.facility_id, Vendor.Vendor_Name order by Facilities.Facility_Name DESC 
		 */
		StringBuilder sql = new StringBuilder();
		
		sql.append("select CONVERT(VARCHAR(10), Facilities.Facility_ID) + ' - ' +Facilities.Facility_Name AS [Facility], ");
		sql.append("VISN.VISN_ID AS [VISN], sum(Facility_Activity.Patient_Totals) AS [Total Patients], ");
		sql.append("sum(Facility_Activity.");
		sql.append(selectedModaility);
		sql.append(") AS [Modality] ");
		sql.append("from Facilities, Facility_Activity, VISN, Vendor ");
		sql.append("where Facility_Activity.Facility_ID=Facilities.ID ");
		sql.append("and Facility_Activity.Rpt_Wk= :reportWeek ");
		sql.append("and Facility_Activity.Vendor_ID=Vendor.Vendor_ID ");
		sql.append("and Vendor.Vendor_ID= :vendorId ");
		sql.append("and VISN.VISN_ID= :visnId ");
		sql.append("and Facilities.VISN_ID=VISN.VISN_ID ");
		sql.append("group by Facilities.facility_Name,VISN.VISN_ID, Facilities.facility_id ");
		sql.append("order by Facilities.Facility_Name DESC");
		
		return sql.toString();
	}

}
