package gov.va.med.ccht.service.dmpreport;


import gov.va.med.ccht.model.car.CensusActivityModalityRecord;
import gov.va.med.ccht.model.car.CensusActivityReportParameters;
import gov.va.med.ccht.model.car.CensusActivityRecord;
import gov.va.med.ccht.model.car.CensusActivityVisnRecord;
import gov.va.med.ccht.model.car.CensusActivitySubTotalRecord;

import gov.va.med.fw.persistent.DAOException;
import gov.va.med.fw.service.ServiceException;


import java.util.List;



public interface CensusActivityReportService 
{	
	public CensusActivityRecord getAllVendorsReportStatus(String reportEndDate) throws ServiceException;
	public CensusActivityRecord getLastReportWeek() throws ServiceException;
	public List<CensusActivityRecord> getNationalReport(CensusActivityReportParameters reportParams)throws ServiceException;
	public List<CensusActivitySubTotalRecord> getSubTotaledNationalReport(CensusActivityReportParameters reportParams)throws ServiceException;
	public List<CensusActivityRecord> getNationalReportByVendor(CensusActivityReportParameters reportParams)throws ServiceException;
	public List<CensusActivityRecord> getNationalReportByModality(CensusActivityReportParameters reportParams) throws ServiceException;
	public List<CensusActivitySubTotalRecord> getSubTotaledNationalReportByModality(CensusActivityReportParameters reportParams)throws ServiceException;
	public List<CensusActivityRecord> getNationalReportByModalityAndVendor(CensusActivityReportParameters reportParams) throws ServiceException;
	public List<CensusActivityVisnRecord> getAllVisnReport(CensusActivityReportParameters reportParams)throws ServiceException;
	public List<CensusActivityVisnRecord> getSubTotaledAllVisnReport(CensusActivityReportParameters reportParams)throws ServiceException;
	public List<CensusActivityVisnRecord> getVisnReportByVendor(CensusActivityReportParameters reportParams) throws ServiceException;	
	public List<CensusActivityVisnRecord> getFacilityDrilldownData(CensusActivityReportParameters params) throws ServiceException;
	public List<CensusActivityVisnRecord> getSingleVisnReport(CensusActivityReportParameters reportParams)throws ServiceException;
	public List<CensusActivityVisnRecord> getSubTotaledSingleVisnReport(CensusActivityReportParameters reportParams)throws ServiceException;
	public List<CensusActivityModalityRecord> getSingleModalityAllVendorAllVisnReport(CensusActivityReportParameters params) throws ServiceException;
	public List<CensusActivityModalityRecord> getSingleModalitySubtotaledVisnReport(CensusActivityReportParameters params) throws ServiceException;
	public List<CensusActivityModalityRecord> getSingleModalitySingleVendorVisnReport(CensusActivityReportParameters reportParams) throws ServiceException;
	public List<CensusActivityModalityRecord> getSingleVisnSingleModalitySubtotaledVisnReport(CensusActivityReportParameters reportParams) throws ServiceException;
	public List<CensusActivityModalityRecord> getModalityFacilityDrilldownData(CensusActivityReportParameters params) throws ServiceException;
	public List<CensusActivityModalityRecord> getSingleVisnSingleModalityAllVendorVisnReport(CensusActivityReportParameters reportParams) throws ServiceException;
	public List<CensusActivityModalityRecord> getSingleVisnSingleModalitySingleVendorReport(CensusActivityReportParameters reportParams) throws ServiceException;
	
	
	public List<CensusActivityVisnRecord> getSingleVisnAllModalitySingleVendorReport(CensusActivityReportParameters reportParams) throws ServiceException;
	
	public void getFacilityReport(CensusActivityReportParameters reportParams)throws ServiceException;
	public String getHdrEndpoint();
	public void setHdrEndpoint(String hdrEndpoint);
}