package gov.va.med.ccht.service.dmpreport.impl;

import gov.va.med.ccht.model.coc.CategoryOfCareReportParameters;
import gov.va.med.ccht.model.coc.CategoryOfCareResult;
import gov.va.med.ccht.persistent.CategoryOfCareReportDAO;
import gov.va.med.ccht.service.common.impl.AbstractBusinessService;
import gov.va.med.ccht.service.dmpreport.CategoryOfCareReportService;
import gov.va.med.fw.persistent.DAOException;
import gov.va.med.fw.service.ServiceException;

public class CategoryOfCareReportServiceImpl extends AbstractBusinessService implements CategoryOfCareReportService
{
    private CategoryOfCareReportDAO categoryOfCareReportDAO;

    public CategoryOfCareReportDAO getCategoryOfCareReportDAO()
    {
        return categoryOfCareReportDAO;
    }

    public void setCategoryOfCareReportDAO(CategoryOfCareReportDAO categoryOfCareReportDAO)
    {
        this.categoryOfCareReportDAO = categoryOfCareReportDAO;
    }

    @Override
    public CategoryOfCareResult getNationalReportAllVendors(CategoryOfCareReportParameters reportParams)
	    throws ServiceException
    {
	try 
	{
		return categoryOfCareReportDAO.getNationalReportAllVendors(reportParams);
	} 
	catch (DAOException e) 
	{
		throw new ServiceException(e.getMessage(), e);
	}
    }

    @Override
    public CategoryOfCareResult getNationalReportByVendor(CategoryOfCareReportParameters reportParams)
	    throws ServiceException
    {
	try 
	{
		return categoryOfCareReportDAO.getNationalReportByVendor(reportParams);
	} 
	catch (DAOException e) 
	{
		throw new ServiceException(e.getMessage(), e);
	}
    }


}
