package gov.va.med.ccht.service.dmpreport.impl;


import gov.va.med.ccht.model.car.CensusActivityModalityRecord;
import gov.va.med.ccht.model.car.CensusActivityRecord;
import gov.va.med.ccht.model.car.CensusActivityReportParameters;
import gov.va.med.ccht.model.car.CensusActivitySubTotalRecord;
import gov.va.med.ccht.model.car.CensusActivityVisnRecord;
import gov.va.med.ccht.model.car.VendorCensusReportStatus;
import gov.va.med.ccht.persistent.CensusActivityReportDAO;
import gov.va.med.ccht.persistent.CensusActivityReportModalityDAO;
import gov.va.med.ccht.service.common.impl.AbstractBusinessService;
import gov.va.med.ccht.service.dmpreport.CensusActivityReportService;
import gov.va.med.cds.ars.ARService;
import gov.va.med.cds.ars.AggregateReportingServiceInterface;
import gov.va.med.cds.ars.HTReportFilterType;
import gov.va.med.cds.ars.HTReportType;
import gov.va.med.cds.ars.ObjectFactory;
import gov.va.med.cds.ars.ReportIDType;
//import gov.va.med.cds.ars.census.weeklyvendorstatusreport.CensusWeeklyVendorReportStatusFilterType;
//import gov.va.med.cds.ars.census.weeklyvendorstatusreport.CensusWeeklyVendorReportStatusType;
//import gov.va.med.cds.ars.census.weeklyvendorstatusreport.CensusWeeklyVendorStatusReportDataType;
import gov.va.med.fw.persistent.DAOException;
import gov.va.med.fw.service.ServiceException;

import java.io.StringReader;
import java.io.StringWriter;
import java.net.URL;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;
import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeConstants;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import javax.xml.namespace.QName;
import javax.xml.transform.stream.StreamSource;



public class CensusActivityReportServiceImpl extends AbstractBusinessService implements
		CensusActivityReportService {
	
	private CensusActivityReportDAO censusActivityReportDAO;
	private CensusActivityReportModalityDAO censusActivityReportModalityDAO;
	
	private String hdrEndpoint;
	private ARService arService;
	AggregateReportingServiceInterface arServicePort;
	
	public CensusActivityReportDAO getCensusActivityReportDAO() 
	{
		return censusActivityReportDAO;
	}

	public void setCensusActivityReportDAO(CensusActivityReportDAO censusActivityReportDAO) 
	{
		this.censusActivityReportDAO = censusActivityReportDAO;
	}
	

	public CensusActivityReportModalityDAO getCensusActivityReportModalityDAO() {
		return censusActivityReportModalityDAO;
	}

	public void setCensusActivityReportModalityDAO(
			CensusActivityReportModalityDAO censusActivityReportModalityDAO) {
		this.censusActivityReportModalityDAO = censusActivityReportModalityDAO;
	}

	public String getHdrEndpoint() {
		return hdrEndpoint;
	}

	public void setHdrEndpoint(String hdrEndpoint) {
		this.hdrEndpoint = hdrEndpoint;
	}

	public ARService getArService() {
		return arService;
	}

	public void setArService(ARService arService) {
		this.arService = arService;
	}

	public AggregateReportingServiceInterface getArServicePort() {
		return arServicePort;
	}

	public void setArServicePort(AggregateReportingServiceInterface arServicePort) {
		this.arServicePort = arServicePort;
	}

	@Override
	public void getFacilityReport(CensusActivityReportParameters reportParams)
			throws ServiceException {
		
		try 
		{
			censusActivityReportDAO.getFacilityReport(reportParams);
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}
	}

	@Override
	public  List<CensusActivityRecord> getNationalReport(CensusActivityReportParameters reportParams)
			throws ServiceException {
		try 
		{
			return censusActivityReportDAO.getNationalReport(reportParams);
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}
		
	}
	
	@Override
	public  List<CensusActivitySubTotalRecord> getSubTotaledNationalReport(CensusActivityReportParameters reportParams)
			throws ServiceException {
		try 
		{
			return censusActivityReportDAO.getSubTotaledNationalReport(reportParams);
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}		
	}

	@Override
	public  List<CensusActivityRecord> getNationalReportByVendor(CensusActivityReportParameters reportParams)
			throws ServiceException {
		try 
		{
			return censusActivityReportDAO.getNationalReportByVendor(reportParams);
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}
		
	}
	
	public List<CensusActivityRecord> getNationalReportByModality(CensusActivityReportParameters reportParams) throws ServiceException
	{
		try 
		{
			return censusActivityReportDAO.getNationalReportByModality(reportParams);
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}
	}
	
	@Override
	public  List<CensusActivitySubTotalRecord> getSubTotaledNationalReportByModality(CensusActivityReportParameters reportParams)
			throws ServiceException {
		try 
		{
			return censusActivityReportDAO.getSubTotaledNationalReportByModality(reportParams);
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}		
	}

	public List<CensusActivityRecord> getNationalReportByModalityAndVendor(CensusActivityReportParameters reportParams) throws ServiceException
	{
		try 
		{
			return censusActivityReportDAO.getNationalReportByModalityAndVendor(reportParams);
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}
	}
	@Override
	public List<CensusActivityVisnRecord> getAllVisnReport(CensusActivityReportParameters reportParams)
			throws ServiceException {
		try 
		{
			return censusActivityReportDAO.getAllVisnReport(reportParams);
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}
		
	}
	
	@Override	
	public List<CensusActivityVisnRecord> getSubTotaledAllVisnReport(CensusActivityReportParameters reportParams)
			throws ServiceException {
		try 
		{
			return censusActivityReportDAO.getSubTotaledAllVisnReport(reportParams);
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}
		catch (Exception e)
		{
			throw new ServiceException(e.getMessage(), e);
		}
		
	}
	
	@Override
	public List<CensusActivityVisnRecord> getVisnReportByVendor(CensusActivityReportParameters reportParams)
			throws ServiceException {
		try 
		{
			return censusActivityReportDAO.getVisnReportByVendor(reportParams);
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}
		
	}
	

	
	@Override
	public List<CensusActivityModalityRecord> getSingleModalityAllVendorAllVisnReport(CensusActivityReportParameters reportParams)
			throws ServiceException {
		try 
		{
			return censusActivityReportModalityDAO.getSingleModalityAllVendorAllVisnReport(reportParams);
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}
		catch (Exception e)
		{
			throw new ServiceException(e.getMessage(), e);
		}
		
	}
	
	@Override
	public List<CensusActivityModalityRecord> getSingleModalitySingleVendorVisnReport(CensusActivityReportParameters reportParams) throws ServiceException
	{
		try 
		{
			return censusActivityReportModalityDAO.getSingleModalitySingleVendorVisnReport(reportParams);
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}
		catch (Exception e)
		{
			throw new ServiceException(e.getMessage(), e);
		}
		
	}
	
	@Override
	public List<CensusActivityVisnRecord> getSingleVisnReport(CensusActivityReportParameters reportParams)
			throws ServiceException {
		try 
		{
			return censusActivityReportDAO.getSingleVisnReport(reportParams);
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}
		
	}
	
	@Override	
	public List<CensusActivityVisnRecord> getSubTotaledSingleVisnReport(CensusActivityReportParameters reportParams)
			throws ServiceException {
		try 
		{
			return censusActivityReportDAO.getSubTotaledSingleVisnReport(reportParams);
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}
		catch (Exception e)
		{
			throw new ServiceException(e.getMessage(), e);
		}
		
	}
	
	public List<CensusActivityVisnRecord> getSingleVisnAllModalitySingleVendorReport(CensusActivityReportParameters reportParams) throws ServiceException
	{
		try 
		{
			return censusActivityReportDAO.getSingleVisnAllModalitySingleVendorReport(reportParams);
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}
		catch (Exception e)
		{
			throw new ServiceException(e.getMessage(), e);
		}
	}
	
	
	public List<CensusActivityModalityRecord> getSingleVisnSingleModalityAllVendorVisnReport(CensusActivityReportParameters reportParams) throws ServiceException
	{
		try 
		{
			return censusActivityReportModalityDAO.getSingleVisnSingleModalityAllVendorVisnReport(reportParams);
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}
		catch (Exception e)
		{
			throw new ServiceException(e.getMessage(), e);
		}
		
	}
	
	public List<CensusActivityModalityRecord> getSingleVisnSingleModalitySingleVendorReport(CensusActivityReportParameters reportParams) throws ServiceException
	{
		try 
		{			
			return censusActivityReportModalityDAO.getSingleVisnSingleModalitySingleVendorReport(reportParams);
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}
		catch (Exception e)
		{
			throw new ServiceException(e.getMessage(), e);
		}
		
	}
	
	public List<CensusActivityModalityRecord> getSingleVisnSingleModalitySubtotaledVisnReport(CensusActivityReportParameters reportParams) throws ServiceException
	{
		
		try 
		{
			return censusActivityReportModalityDAO.getSingleVisnSingleModalitySubtotaledVisnReport(reportParams);
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}
		catch (Exception e)
		{
			throw new ServiceException(e.getMessage(), e);
		}
	}
	
	@Override
	public List<CensusActivityModalityRecord> getSingleModalitySubtotaledVisnReport(CensusActivityReportParameters reportParams)
			throws ServiceException {
		try 
		{
			return censusActivityReportModalityDAO.getSingleModalitySubtotaledVisnReport(reportParams);
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}
		catch (Exception e)
		{
			throw new ServiceException(e.getMessage(), e);
		}
		
	}
	

	
	
			
	public CensusActivityRecord getLastReportWeek() throws ServiceException
	{
		try 
		{
			CensusActivityRecord retVal = censusActivityReportDAO.getLastReportWeek(); 
			return retVal;
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}
	}
	
	public CensusActivityRecord getAllVendorsReportStatus(String reportEndDate) throws ServiceException
	{
		/*
		//ALL Standard vendors 
		ObjectFactory of = new ObjectFactory();
		CensusActivityRecord censusActivityRecord = new CensusActivityRecord();
			try
			{ 
				this.arService=new ARService(new URL("http://DNS   ho-qi.DNS   .med.DNS   :6033/AggregateReportingService/ARService"),new QName("http://cds.med.DNS   /", "ARService"));
				//this.arService=new ARService(new URL(this.hdrEndpoint),new QName("http://cds.med.DNS   /", "ARService"));

				arServicePort=this.arService.getAggregateReportingServicePort();
			}
			catch(Exception e)
			{
				logger.error(e.getMessage());
				throw new ServiceException("No arService");
				
			}
			boolean arServiceAvailable = arServicePort.isAlive();
			if(!arServiceAvailable)
			{
				logger.error("No arService");
				throw new ServiceException("No arService");
			}
			else
			{
				HTReportFilterType htReportFilterType =of.createHTReportFilterType();
				
				CensusWeeklyVendorReportStatusFilterType censusWeeklyVendorReportStatusFilterType = of.createCensusWeeklyVendorReportStatusFilterType();
				
				censusWeeklyVendorReportStatusFilterType.setReportID(ReportIDType.CENSUS_WEEKLY_VENDOR_STATUS_REPORT);
				GregorianCalendar gcStartDate = new GregorianCalendar(2013, 9, 6);
				GregorianCalendar gcEndDate = new GregorianCalendar(2013, 9, 12);
				censusWeeklyVendorReportStatusFilterType.setStartDate(this.getMarshalDate(gcStartDate.get(Calendar.YEAR),gcStartDate.get(Calendar.MONTH), gcStartDate.get(Calendar.DAY_OF_MONTH)));  //only for testing remove
		        censusWeeklyVendorReportStatusFilterType.setEndDate(this.getMarshalDate(gcEndDate.get(Calendar.YEAR),gcEndDate.get(Calendar.MONTH), gcEndDate.get(Calendar.DAY_OF_MONTH)));
	
				htReportFilterType.setCensusWeeklyVendorReportStatusFilter(censusWeeklyVendorReportStatusFilterType);

			    JAXBElement<HTReportFilterType> jaxbFilterElement = of.createHtReportFilter(htReportFilterType);
				JAXBContext context=null;
				StringWriter writer = new StringWriter();
				
				List<VendorCensusReportStatus> vendorCensusReportStatusList = new ArrayList<VendorCensusReportStatus>();
				try 
				{
					context = JAXBContext.newInstance(HTReportFilterType.class);
					Marshaller marshaller=null;
					marshaller = context.createMarshaller();
					marshaller.marshal(jaxbFilterElement, writer);
				    String result = arServicePort.readAggregateData(writer.toString(), ReportIDType.CENSUS_WEEKLY_VENDOR_STATUS_REPORT.name(), "HTAPPL", "1");
				    StringReader resultReader = new StringReader(result);
				    
				    
				    
				    
				    
					JAXBContext jaxbResult=JAXBContext.newInstance(HTReportType.class);
					Unmarshaller jaxbUnmarshaler = jaxbResult.createUnmarshaller();
					JAXBElement<HTReportType> vendorData=jaxbUnmarshaler.unmarshal(new StreamSource(resultReader),HTReportType.class);
					//List<CensusWeeklyVendorReportStatusType> o = vendorData.getValue().getResponse().getCensusVendorWeeklyReportData().getVendorList();
					

					censusActivityRecord.setVendorCensusReportStatus(vendorCensusReportStatusList);
				} catch (Exception e) {
					throw new ServiceException("arService JAXBException");				}
			}
			return censusActivityRecord;
			*/
		
		try 
		{
			CensusActivityRecord retVal = censusActivityReportDAO.getAllVendorsReportStatus(reportEndDate);
			return retVal;
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}
		
	}
	
	

	@Override
	public List<CensusActivityVisnRecord> getFacilityDrilldownData(
			CensusActivityReportParameters params) throws ServiceException {
		try 
		{
			return censusActivityReportDAO.getFacilityDrilldownData(params);
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}
		catch (Exception e)
		{
			throw new ServiceException(e.getMessage(), e);
		}
	}

	public List<CensusActivityModalityRecord> getModalityFacilityDrilldownData(CensusActivityReportParameters params) throws ServiceException
	{
		try 
		{			
			return censusActivityReportModalityDAO.getFacilityDrilldownData(params);
		} 
		catch (DAOException e) 
		{
			throw new ServiceException(e.getMessage(), e);
		}
		catch (Exception e)
		{
			throw new ServiceException(e.getMessage(), e);
		}
	}
	
	private XMLGregorianCalendar getMarshalDate(int year, int month, int day) 
	{
		
			XMLGregorianCalendar xmlGcDate=null;
			try {
				xmlGcDate = DatatypeFactory.newInstance().newXMLGregorianCalendar(new GregorianCalendar(year,month,day));
				xmlGcDate.setMillisecond(DatatypeConstants.FIELD_UNDEFINED);
				xmlGcDate.setTimezone(DatatypeConstants.FIELD_UNDEFINED);
				xmlGcDate.setMinute(DatatypeConstants.FIELD_UNDEFINED);
				xmlGcDate.setHour(DatatypeConstants.FIELD_UNDEFINED);
				xmlGcDate.setSecond(DatatypeConstants.FIELD_UNDEFINED);		
				} 
			catch (DatatypeConfigurationException e) {
				logger.error(e.getMessage());
			}

			return xmlGcDate;
	}

}
