package gov.va.med.ccht.controller;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import org.apache.commons.lang.StringUtils;
import org.jfree.util.Log;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;

import gov.va.med.ccht.model.User;
import gov.va.med.ccht.model.dmp.DMP;
import gov.va.med.ccht.model.dmp.DMPFindReplaceCriteria;
import gov.va.med.ccht.model.dmp.DMPQuestion;
import gov.va.med.ccht.model.dmp.DMPResponse;
import gov.va.med.ccht.model.dmp.DMPReview;
import gov.va.med.ccht.model.dmp.DMPSearch;
import gov.va.med.ccht.model.dmp.DMPSearchParameters;
import gov.va.med.ccht.model.dmp.DMPStandLibEntry;
import gov.va.med.ccht.model.dmp.DMPToolUser;
import gov.va.med.ccht.model.dmp.DMPVendorDeployment;
import gov.va.med.ccht.model.inventory.Vendor;
import gov.va.med.ccht.model.terminology.RegistrationStatus;
import gov.va.med.ccht.ui.common.AbstractController;
import gov.va.med.ccht.ui.model.DMPForm;
import gov.va.med.ccht.ui.model.DMPSearchForm;
import gov.va.med.ccht.ui.model.DmpAssignee;
import gov.va.med.ccht.ui.model.UserForm;
import gov.va.med.ccht.util.DMPExport;
import gov.va.med.fw.model.EntityKey;
import gov.va.med.fw.model.EntityKeyFactory;
import gov.va.med.fw.model.ldap.SearchCriteria;
import gov.va.med.fw.ui.model.TermType;

@Controller
public class DMPController extends AbstractController {

//	@Autowired
//	private DMPConversionService dmpConversionService;
//	@Autowired
//	private SecurityController securityController;

	private final int LOCKED_INDICATOR = 1;
	private final int UNLOCKED_INDICATOR = 0;

//	public List<DMP> searchDMP(DMP dmp) throws Exception {
//		List<DMP> results = new ArrayList<DMP>();
//		results = dmpService.searchDMP(dmp);
//
//		return results;
//	}

//	public DMPFindReplaceCriteria findTermInDMP(DMPFindReplaceCriteria criteria) throws Exception {
//		return dmpService.findTermInDMP(criteria);
//	}

//	public DMPFindReplaceCriteria replaceTermInDMP(DMPFindReplaceCriteria criteria) throws Exception {
//		try {
//			return dmpService.updateDMPwithReplaceTerm(criteria);
//		} catch (Exception e) {
//			if (e.getMessage().indexOf("Column size limit exceeded") > -1) {
//				criteria.setException("Column size limit exceeded");
//				return criteria;
//			}
//			throw e;
//		}
//	}

//	public DMPForm getDMP(String id) throws Exception {
//		EntityKey<DMP> entityKey = EntityKeyFactory.createEntityKey(new Long(id), DMP.class);
//		DMP dmp = dmpService.getDMP(entityKey);
//		DMPForm dmpForm = new DMPForm();
//		getDmpConversionService().convert(dmp, dmpForm);
//		dmpForm = this.refreshDmpForm(dmpForm, dmp);
//		return dmpForm;
//	}

//	public List<DMPForm> getAssignedDmps(String userId) throws Exception {
//		List<DMPForm> results = new ArrayList<DMPForm>();
//		List<DMP> rawResults = dmpService.findAssigedDmps(userId);
//
//		for (DMP dmp : rawResults) {
//			DMPForm dmpForm = new DMPForm();
//			dmpForm = this.refreshDmpForm(dmpForm, dmp);
//			///////// fchen 10/14/12: HTCE_CodeCR805 /////
//			dmpForm.setModifiedBy(dmp.getModifiedByName());
//			dmpForm.setModifiedDate(dmp.getModifiedOn().toString());
//			//////// end of HTCE_CodeCR805 /////////////
//			results.add(dmpForm);
//		}
//		return results;
//	}

//	@SuppressWarnings("unchecked")
//	public List<DMPForm> getAdminViewMyDmps(String userId) throws Exception {
//		List<DMPForm> results = new ArrayList<DMPForm>();
//		List<DMP> rawResults = dmpService.findAdminViewMyDmps(userId);
//		Collections.sort(rawResults, new Comparator()
//
//		{
//			public int compare(Object obj1, Object obj2) {
//				DMP dmp1 = (DMP) obj1;
//				DMP dmp2 = (DMP) obj2;
//				return (dmp1.getName().compareToIgnoreCase(dmp2.getName()));
//			}
//		});
//		// Collections.reverse(rawResults);
//		for (DMP dmp : rawResults) {
//			DMPForm dmpForm = new DMPForm();
//			dmpForm = this.refreshDmpForm(dmpForm, dmp);
//			results.add(dmpForm);
//		}
//		return results;
//	}

//	public List<DMPForm> getAllAssignedDmps(String loginUserId) throws Exception {
//		List<DMPForm> results = new ArrayList<DMPForm>();
//		List<DMP> rawResults = dmpService.findAllDmps();
//		for (DMP dmp : rawResults) {
//			DMPForm dmpForm = new DMPForm();
//			dmpForm.setDmp(dmp);
//			dmpForm.setId(String.valueOf(dmp.getId()));
//			getDmpConversionService().processDMPTypes(dmpForm);
//			dmpForm.setDmpToolUsers(dmpService.findDMPToolUsers(dmp));
//			ArrayList<DMPQuestion> dmpQuestions = new ArrayList<DMPQuestion>(dmp.getQuestions());
//			for (DMPQuestion dmpQuestion : dmpQuestions) {
//				getDmpConversionService().processQuestionResponse(dmpQuestion);
//				getDmpConversionService().processQuestionContent(dmpQuestion);
//			}
//			dmpForm.setQuestions(dmpQuestions);
//			try {
//				if (dmp.getModifiedBy() != null) {
//					if (dmp.getModifiedBy().getChangeUser() != null) {
//						dmpForm.setModifiedBy(getUser(dmp.getModifiedBy().getChangeUser()).getFullName());
//					}
//				}
//			} catch (Exception e) {
//				dmpForm.setModifiedBy(dmp.getModifiedBy().getChangeUser());
//				// logger.error("DMP modifiedBy not available for user: "
//				// + dmp.getModifiedBy().getChangeUser());
//			}
//			try {
//
//				if (dmp.getCreatedBy() != null) {
//					if (dmp.getCreatedBy().getChangeUser() != null) {
//						dmpForm.setCreatedBy(getUser(dmp.getCreatedBy().getChangeUser()).getFullName());
//					}
//				}
//			} catch (Exception e) {
//				dmpForm.setCreatedBy(dmp.getCreatedBy().getChangeUser());
//				// logger.error("DMP createdBy not available for user: "
//				// + dmp.getCreatedBy().getChangeUser());
//			}
//			results.add(dmpForm);
//		}
//		return results;
//	}

//	public DMPForm assignDmp(DMPForm dmpForm) throws Exception {
//		List<DmpAssignee> dmpAssignees = dmpForm.getAssignees();
//		DMP dmp = dmpService.findDMPById(dmpForm.getId());
//		for (DmpAssignee dmpAssignee : dmpAssignees) {
//			if (dmpAssignee.getIsAssigned() && !dmpAssignee.isDisableNewUserAssignment()) {
//				DMPToolUser newAssignee = new DMPToolUser();
//				User assingedUser = dmpService.getUserByLoginId(dmpAssignee.getUserForm().getUserName());
//				newAssignee.setAppUser(assingedUser);
//				newAssignee.setAssigned(true);
//				newAssignee.setDmp(dmp);
//				newAssignee.setIsAssigned(true);
//				dmpService.saveDMPToolUser(newAssignee, true);
//			}
//		}
//		dmp = dmpService.saveDMP(dmp);
//		dmp = dmpService.findDMPById(dmpForm.getId());
//		dmpForm = this.refreshDmpForm(dmpForm, dmp);
//		return dmpForm;
//	}

//	public DMPExport exportDmp(DMPForm dmpForm) throws Exception {
//		DMPExport dmpExport = new DMPExport();
//		dmpExport = dmpService.createDmpExportContent(dmpForm.getId());
//		return dmpExport;
//	}

//	public DMPForm saveResponse(DMPForm dmpForm) throws Exception {
//		// dmpForm.getSelectedResponse();
//		EntityKey<DMPQuestion> entityKey = EntityKeyFactory.createEntityKey(dmpForm.getSelectedQuestion().getId(),
//				DMPQuestion.class);
//		DMPQuestion question = dmpService.getDMPQuestion(entityKey);
//		question.setQuestionResponseTermType(dmpForm.getSelectedQuestion().getQuestionResponseTermType());
//		question.setQuestionContentTermType(dmpForm.getSelectedQuestion().getQuestionContentTermType());
//		getDmpConversionService().processQuestionResponseTermType(question);
//		getDmpConversionService().processQuestionContentTermType(question);
//		question = dmpService.saveDMPQuestion(question);
//		EntityKey<DMP> dmpEntityKey = EntityKeyFactory.createEntityKey(Long.parseLong(dmpForm.getId()), DMP.class);
//		DMP dmp = dmpService.getDMP(dmpEntityKey);
//		ArrayList<DMPResponse> savedResponses = new ArrayList<DMPResponse>();
//		for (DMPResponse aResponse : dmpForm.getSelectedResponses()) {
//			DMPResponse response = null;
//			if (aResponse.getId() != null && aResponse.getId() > 0) {
//				EntityKey<DMPResponse> responseEntityKey = EntityKeyFactory.createEntityKey(aResponse.getId(),
//						DMPResponse.class);
//				response = dmpService.getDMPResponse(responseEntityKey);
//			}
//			if (response == null) {
//				response = new DMPResponse();
//			}
//			response.setResponseContent(aResponse.getResponseContent());
//			response.setVendorInstrContent(aResponse.getVendorInstrContent());
//			response.setEduContent(aResponse.getEduContent());
//			response.setQuestion(question);
//			if (aResponse.getAlertLevel() != null && aResponse.getAlertLevel() == 0) {
//				response.setAlertLevel(null);
//			} else {
//				response.setAlertLevel(aResponse.getAlertLevel());
//			}
//
//			response.setBranchId(aResponse.getBranchId());
//			response = dmpService.saveDMPResponse(response);
//
//			savedResponses.add(response);
//		}
//		question.setResponses(new HashSet<DMPResponse>(savedResponses));
//		question = dmpService.saveDMPQuestion(question);
//		dmp = dmpService.saveDMP(dmp);
//		dmp = dmpService.findDMPById(dmpForm.getId());
//		dmpForm.setDmp(dmp);
//		dmpForm.setSelectedQuestion(question);
//		// dmpForm.setSelectedResponse(response);
//		dmpForm.setSelectedResponses(savedResponses);
//		dmpForm = refreshDmpForm(dmpForm, dmp);
//
//		return dmpForm;
//	}

//	public DMPForm saveQuestion(DMPForm dmpForm) throws Exception {
//		DMPQuestion question = dmpForm.getSelectedQuestion();
//		getDmpConversionService().processQuestionResponseTermType(question);
//		getDmpConversionService().processQuestionContentTermType(question);
//		DMP dmp = dmpService.findDMPById(dmpForm.getId());
//		if (question.getContentOrder() == -1) {
//			question.setContentOrder(dmp.getQuestions().size() + 1);
//		}
//		question.setDmp(dmp);
//		question.setResponses(null);
//		question = dmpService.saveDMPQuestion(question);
//		getDmpConversionService().processQuestionContentTermType(question);
//		dmp = dmpService.saveDMP(dmp);
//		dmp = dmpService.findDMPById(dmpForm.getId());
//		dmpForm.setDmp(dmp);
//		dmpForm.setSelectedQuestion(question);
//		dmpForm = refreshDmpForm(dmpForm, dmp);
//		return dmpForm;
//	}

//	public DMPForm unAssignDmp(DMPForm dmpForm) throws Exception {
//		DMP dmp = dmpService.findDMPById(dmpForm.getId());
//		Set<DMPToolUser> assignees = dmp.getAssignees();
//		List<DmpAssignee> dmpUnassignees = dmpForm.getAssignees();
//		for (DMPToolUser potentialUnassignee : assignees) {
//			for (DmpAssignee dmpAssignee : dmpUnassignees) {
//				if (dmpAssignee.getIsAssigned()) {
//					if (Long.parseLong(dmpAssignee.getDmpToolUserId()) == potentialUnassignee.getId().longValue()) {
//						potentialUnassignee.setIsAssigned(false);
//						potentialUnassignee.setAssigned(false);
//						dmpService.saveDMPToolUser(potentialUnassignee, true);
//						// dmpService.deleteDMPToolUser(
//						// potentialUnassignee.getEntityKey());
//					}
//				}
//			}
//		}
//		dmp = dmpService.findDMPById(dmpForm.getId());
//		dmp = dmpService.saveDMP(dmp);
//		dmp = dmpService.findDMPById(dmpForm.getId());
//		dmpForm = refreshDmpForm(dmpForm, dmp);
//		return dmpForm;
//	}

//	public List<DmpAssignee> findUsers(SearchCriteria searchCriteria, DMPForm dmp) throws Exception {
//		List<DmpAssignee> dmpAssignees = new ArrayList<DmpAssignee>();
//		List<DMPToolUser> dmpToolUsers = dmpService.findDMPToolUsers(dmp.getId());
//		List<User> cchtUsers = securityService.findAppUsers(searchCriteria);
//		if (cchtUsers != null && cchtUsers.size() > 0) {
//			// found users
//			for (User user : cchtUsers) {
//				DmpAssignee dmpAssignee = new DmpAssignee();
//				UserForm userForm = securityController.getUser(user.getName());
//				user.setGivenName(userForm.getGivenName() + " - USER ALREADY ASSIGNED");
//				dmpAssignee.setUser(user);
//				dmpAssignee.setUserForm(userForm);
//				for (DMPToolUser dmpToolUser : dmpToolUsers) {
//					if (dmpToolUser.getAppUser().getName().equalsIgnoreCase(user.getName())) {
//						if (dmpToolUser.isAssigned()) {
//							dmpAssignee.setDisableNewUserAssignment(true);
//							dmpAssignee.setIsAssigned(true);
//						} else {
//							dmpAssignee.setDisableNewUserAssignment(false);
//							dmpAssignee.setIsAssigned(false);
//						}
//						if (dmpToolUser.isReviewer()) {
//							dmpAssignee.setDisableNewUserReviewerAssignment(true);
//							dmpAssignee.setReviewer(true);
//						} else {
//							dmpAssignee.setDisableNewUserReviewerAssignment(false);
//							dmpAssignee.setReviewer(false);
//						}
//						dmpAssignee.setDmpToolUserId(dmpToolUser.getId().toString());
//						// dmpAssignee.setDisableNewUserAssignment(true);
//						// dmpAssignee.setIsAssigned(true);
//						if (!dmpToolUser.getAppUser().getRegistrationStatus().getCode()
//								.equals(RegistrationStatus.APPROVED)) {
//							dmpAssignee.setDisableNewUserAssignment(true);
//							dmpAssignee.setDisableNewUserReviewerAssignment(true);
//						}
//						break;
//					}
//
//				}
//				dmpAssignees.add(dmpAssignee);
//			}
//		}
//		return dmpAssignees;
//	}

//	public List<DmpAssignee> findDmpAssignees(DMPForm dmp) throws Exception {
//		List<DmpAssignee> dmpAssignees = new ArrayList<DmpAssignee>();
//		List<DMPToolUser> dmpToolUsers = dmpService.findDMPToolUsers(dmp.getId());
//		if (dmpToolUsers != null && dmpToolUsers.size() > 0) {
//			for (DMPToolUser dmpToolUser : dmpToolUsers) {
//				if (dmpToolUser.isAssigned()) {
//					UserForm userForm = securityController.getUser(dmpToolUser.getAppUser().getName());
//					DmpAssignee dmpAssignee = new DmpAssignee();
//					dmpAssignee.setDmpToolUserId(dmpToolUser.getId().toString());
//					dmpAssignee.setUser(dmpToolUser.getAppUser());
//					dmpAssignee.setUserForm(userForm);
//					dmpAssignee.setAssigned(dmpToolUser.isAssigned());
//					dmpAssignees.add(dmpAssignee);
//				}
//			}
//		}
//		// sort dmpAssignees
//		Collections.sort(dmpAssignees, new Comparator<DmpAssignee>() {
//			@Override
//			public int compare(DmpAssignee entry1, DmpAssignee entry2) {
//				String e1 = formatName(entry1.getUserForm()).toLowerCase();
//				String e2 = formatName(entry2.getUserForm()).toLowerCase();
//				/*
//				 * String e1 = formatName(entry1.getUserForm()) +
//				 * entry1.getVisnFacility() == null ? "" :
//				 * entry1.getVisnFacility() + entry1.getUserForm() == null ||
//				 * entry1.getUserForm().getTelephoneNumber() == null ? "" :
//				 * entry1.getUserForm().getTelephoneNumber() +
//				 * entry1.getUserForm() == null ||
//				 * entry1.getUserForm().getEmail() == null ? "" :
//				 * entry1.getUserForm().getEmail(); String e2 =
//				 * formatName(entry2.getUserForm()) + entry2.getVisnFacility()
//				 * == null ? "" : entry2.getVisnFacility() +
//				 * entry2.getUserForm() == null ||
//				 * entry2.getUserForm().getTelephoneNumber() == null ? "" :
//				 * entry2.getUserForm().getTelephoneNumber() +
//				 * entry2.getUserForm() == null ||
//				 * entry2.getUserForm().getEmail() == null ? "" :
//				 * entry2.getUserForm().getEmail();
//				 */
//				return e1.compareTo(e2);
//			}
//		});
//
//		return dmpAssignees;
//	}

//	public List<DMPQuestion> findDmpQuestions(DMPForm dmpForm) {
//		List<DMPQuestion> questions = dmpForm.getQuestions();
//		for (int i = 0; i < questions.size(); i++) {
//			DMPQuestion question = questions.get(i);
//			question.setQuestionOrder(i + "");
//		}
//		return questions;
//	}

//	public List<DMPQuestion> getAllStandardizedLibs(DMPForm dmpForm) {
//		List<DMPQuestion> questions = dmpForm.getQuestions();
//		for (int i = 0; i < questions.size(); i++) {
//			DMPQuestion question = questions.get(i);
//			question.setQuestionOrder(i + "");
//		}
//		return questions;
//	}

//	public DMPForm deleteQuestions(DMPForm dmpForm) throws Exception {
//		DMP dmp = dmpService.findDMPById(dmpForm.getId());
//		List<DMPQuestion> deletedQuestions = dmpForm.getDeletedQuestions();
//		for (DMPQuestion deletedQuestion : deletedQuestions) {
//			if (deletedQuestion.getMarkAsDeleted()) {
//				dmpService.deleteDMPQuestion(deletedQuestion.getEntityKey());
//			}
//		}
//		dmp = dmpService.findDMPById(dmpForm.getId());
//		dmp = dmpService.saveDMP(dmp);
//		logger.debug("setting new orderfor all questions");
//		ArrayList<DMPQuestion> questions = new ArrayList<DMPQuestion>(dmp.getQuestions());
//		int qCount = 1;
//		for (DMPQuestion aQuestion : questions) {
//			aQuestion.setContentOrder(qCount);
//			logger.debug("setting new order for qid: " + aQuestion.getId().toString() + ", qCount:  " + qCount
//					+ ", order: " + aQuestion.getContentOrder());
//			aQuestion = dmpService.saveDMPQuestion(aQuestion);
//			qCount++;
//		}
//		dmp = dmpService.findDMPById(dmpForm.getId());
//		dmpForm = refreshDmpForm(dmpForm, dmp);
//		return dmpForm;
//	}

//	public DMPForm deleteQuestion(DMPForm dmpForm) throws Exception {
//		DMP dmp = dmpService.findDMPById(dmpForm.getId());
//		DMPQuestion deletedQuestion = dmpForm.getSelectedQuestion();
//		dmpService.deleteDMPQuestion(deletedQuestion.getEntityKey());
//		dmp = dmpService.findDMPById(dmpForm.getId());
//		dmp = dmpService.saveDMP(dmp);
//		logger.debug("setting new orderfor all questions");
//		ArrayList<DMPQuestion> questions = new ArrayList<DMPQuestion>(dmp.getQuestions());
//		int qCount = 1;
//		for (DMPQuestion aQuestion : questions) {
//			aQuestion.setContentOrder(qCount);
//			logger.debug("setting new order for qid: " + aQuestion.getId().toString() + ", qCount:  " + qCount
//					+ ", order: " + aQuestion.getContentOrder());
//			aQuestion = dmpService.saveDMPQuestion(aQuestion);
//			qCount++;
//		}
//		dmp = dmpService.findDMPById(dmpForm.getId());
//		dmpForm = refreshDmpForm(dmpForm, dmp);
//		return dmpForm;
//	}

//	public DMPConversionService getDmpConversionService() {
//		return dmpConversionService;
//	}

//	public void addDMP(DMPForm dmpForm) throws Exception {
//		getDmpConversionService().processTermTypes(dmpForm);
//		dmpService.saveDMP(dmpForm.getDmp());
//	}

//	public Boolean isDmpStandLibEntryDuplicate(DMPStandLibEntry dmpStandLibEntry) throws Exception {
//		getDmpConversionService().processDmpStandLibEntryTermTypes(dmpStandLibEntry);
//		return dmpService.isDmpStandLibEntryDuplicate(dmpStandLibEntry);
//	}

//	public DMPStandLibEntry addStandLibEntry(DMPStandLibEntry dmpStandLibEntry) throws Exception {
//		getDmpConversionService().processDmpStandLibEntryTermTypes(dmpStandLibEntry);
//		dmpStandLibEntry = dmpService.saveDMPStandLibEntry(dmpStandLibEntry);
//		getDmpConversionService().processDmpStandLibEntryTypes(dmpStandLibEntry);
//		return dmpStandLibEntry;
//	}

//	public DMPStandLibEntry updateStandLibEntry(DMPStandLibEntry dmpStandLibEntry) throws Exception {
//		getDmpConversionService().processDmpStandLibEntryTermTypes(dmpStandLibEntry);
//		DMPStandLibEntry persitedDmpStandLibEntry = dmpService.findDMPStanLibEntryById(dmpStandLibEntry.getId());
//		persitedDmpStandLibEntry.setCeOtherText(dmpStandLibEntry.getCeOtherText());
//		persitedDmpStandLibEntry.setClinicalEvidenceOther(dmpStandLibEntry.getClinicalEvidenceOther());
//		persitedDmpStandLibEntry.setClinicalEvidenceVA(dmpStandLibEntry.getClinicalEvidenceVA());
//		persitedDmpStandLibEntry.setClinicalEvidenceAhrq(dmpStandLibEntry.getClinicalEvidenceAhrq());
//		persitedDmpStandLibEntry.setModifiedBy(dmpStandLibEntry.getModifiedBy());
//		persitedDmpStandLibEntry.setModifiedInTimeZone(dmpStandLibEntry.getModifiedInTimeZone());
//		persitedDmpStandLibEntry.setModifiedOn(dmpStandLibEntry.getModifiedOn());
//		persitedDmpStandLibEntry.setReasonModTermType(dmpStandLibEntry.getReasonModTermType());
//		persitedDmpStandLibEntry.setReasonModType(dmpStandLibEntry.getReasonModType());
//		persitedDmpStandLibEntry.setRsnModComment(dmpStandLibEntry.getRsnModComment());
//		persitedDmpStandLibEntry.setSlCategoryTermType(dmpStandLibEntry.getSlCategoryTermType());
//		persitedDmpStandLibEntry.setSlCategoryType(dmpStandLibEntry.getSlCategoryType());
//		persitedDmpStandLibEntry.setSlContent(dmpStandLibEntry.getSlContent());
//		persitedDmpStandLibEntry.setSlContentTermType(dmpStandLibEntry.getSlCategoryTermType());
//		persitedDmpStandLibEntry.setSlContentType(dmpStandLibEntry.getSlContentType());
//		dmpStandLibEntry = dmpService.saveDMPStandLibEntry(persitedDmpStandLibEntry);
//		getDmpConversionService().processDmpStandLibEntryTypes(persitedDmpStandLibEntry);
//		return persitedDmpStandLibEntry;
//	}

//	public List<DMPStandLibEntry> getAllStandLibEntries() throws Exception {
//		List<DMPStandLibEntry> results = dmpService.getAllStandardLibs();
//		List<DMPStandLibEntry> processedResults = new ArrayList<DMPStandLibEntry>();
//		for (DMPStandLibEntry libEntry : results) {
//			getDmpConversionService().processDmpStandLibEntryTypes(libEntry);
//			processedResults.add(libEntry);
//		}
//		return processedResults;
//	}

//	public DMPForm updateDmp(DMPForm dmpForm) throws Exception {
//		getDmpConversionService().processTermTypes(dmpForm);
//		EntityKey<DMP> entityKey = EntityKeyFactory.createEntityKey(Long.parseLong(dmpForm.getId()), DMP.class);
//		DMP dmp = dmpService.getDMP(entityKey);
//		dmp.setTag(dmpForm.getDmp().getTag());
//		dmp.setName(dmpForm.getDmp().getName());
//		dmp.setObjective(dmpForm.getDmp().getObjective());
//		dmp.setDescription(dmpForm.getDmp().getDescription());
//		dmp.setDmpStatusType(dmpForm.getDmp().getDmpStatusType());
//		dmp.setDmpVersion(dmpForm.getDmp().getDmpVersion());
//		dmp = dmpService.saveDMP(dmp);
//		dmpForm = this.refreshDmpForm(dmpForm, dmp);
//		return dmpForm;
//	}

//	public DMPForm updateQuestionListLocks(List<DMPQuestion> lockChangedQs, DMPForm dmpForm) throws Exception {
//		DMPForm updatedDMP = null;
//		List<Long> lockedQuestions = new ArrayList<Long>();
//		List<Long> unLockedQuestions = new ArrayList<Long>();
//
//		// Separate the questions into a locked or unlocked list
//		for (DMPQuestion aQuestion : lockChangedQs) {
//			boolean locked = aQuestion.getLocked();
//
//			if (locked) {
//				lockedQuestions.add(aQuestion.getId());
//			} else {
//				unLockedQuestions.add(aQuestion.getId());
//			}
//
//		}
//
//		if (lockedQuestions.size() > 0) {
//			dmpService.updateDmpQuestionsLockStatus(lockedQuestions, LOCKED_INDICATOR);
//		}
//
//		if (unLockedQuestions.size() > 0) {
//			dmpService.updateDmpQuestionsLockStatus(unLockedQuestions, UNLOCKED_INDICATOR);
//		}
//
//		DMP dmp = dmpService.findDMPById(dmpForm.getId());
//		updatedDMP = refreshDmpForm(dmpForm, dmp);
//		updatedDMP.setSearchScreen(dmpForm.getSearchScreen());
//		return updatedDMP;
//	}

//	public DMPForm updateQuestion(DMPForm dmpForm) throws Exception {
//		// getDmpConversionService().processTermTypes(dmpForm);
//		EntityKey<DMPQuestion> entityKey = EntityKeyFactory.createEntityKey(dmpForm.getSelectedQuestion().getId(),
//				DMPQuestion.class);
//		DMPQuestion question = dmpService.getDMPQuestion(entityKey);
//		question.setQuestionContent(dmpForm.getSelectedQuestion().getQuestionContent());
//		question.setFrequency(dmpForm.getSelectedQuestion().getFrequency());
//		int newOrder = dmpForm.getSelectedQuestion().getContentOrder();
//		int oldOrder = question.getContentOrder();
//		question.setContentOrder(dmpForm.getSelectedQuestion().getContentOrder());
//		question.setQuestionContentTermType(dmpForm.getSelectedQuestion().getQuestionContentTermType());
//		question.setQuestionResponseTermType(dmpForm.getSelectedQuestion().getQuestionResponseTermType());
//		question.setLocked(dmpForm.getSelectedQuestion().getLocked());
//
//		if (question.getQuestionResponseTermType().getLabel().equalsIgnoreCase("No response")
//				|| !question.getQuestionContentTermType().getLabel().equalsIgnoreCase("Question/Statement")
//				|| !question.getDmpResponseType().getDescription()
//						.equalsIgnoreCase(dmpForm.getSelectedQuestion().getQuestionResponseTermType().getLabel())) {
//			Iterator<DMPResponse> iterator = question.getResponses().iterator();
//			while (iterator.hasNext()) {
//				DMPResponse deletedResponse = iterator.next();
//				deletedResponse.setAlertLevel(null);
//				deletedResponse.setBranchId(null);
//				deletedResponse.setEduContent(null);
//				deletedResponse.setResponseContent(null);
//				deletedResponse.setVendorInstrContent(null);
//			}
//		}
//		getDmpConversionService().processQuestionResponseTermType(question);
//		getDmpConversionService().processQuestionContentTermType(question);
//		boolean changeDmpQuestionOrder = false;
//		if (newOrder != oldOrder) {
//			changeDmpQuestionOrder = true;
//		}
//		// question.setContentOrder(newOrder);
//		EntityKey<DMP> dmpEntityKey = EntityKeyFactory.createEntityKey(Long.parseLong(dmpForm.getId()), DMP.class);
//		DMP dmp = dmpService.getDMP(dmpEntityKey);
//		if (changeDmpQuestionOrder) {
//			logger.debug("setting new orderfor all questions");
//			// getDmpConversionService().processTermTypes(dmpForm);
//			ArrayList<DMPQuestion> questions = new ArrayList<DMPQuestion>(dmp.getQuestions());
//			questions.remove(oldOrder - 1);
//			questions.add(newOrder - 1, question);
//			int qCount = 1;
//			for (DMPQuestion aQuestion : questions) {
//				/*
//				 * EntityKey<DMPQuestion> dmpQentityKey = EntityKeyFactory
//				 * .createEntityKey(aQuestion.getId(), DMPQuestion.class);
//				 * DMPQuestion dmpQ = dmpService.getDMPQuestion(dmpQentityKey);
//				 */
//				aQuestion.setContentOrder(qCount);
//				logger.debug("setting new order for qid: " + aQuestion.getId().toString() + ", qCount:  " + qCount
//						+ ", order: " + aQuestion.getContentOrder());
//				aQuestion = dmpService.saveDMPQuestion(aQuestion);
//				// dmpService.updateDMPQuestion(aQuestion);
//				qCount++;
//			}
//
//		} else {
//			question = dmpService.saveDMPQuestion(question);
//		}
//		dmp = dmpService.getDMP(dmpEntityKey);
//		dmpForm = this.refreshDmpForm(dmpForm, dmp);
//		// dmpForm.setQuestions(new
//		// ArrayList<DMPQuestion>(dmp.getQuestions()));
//		dmpForm.setSelectedQuestion(question);
//		// dmpForm.setSelectedResponses(new
//		// ArrayList<DMPResponse>(question.getResponses()));
//		return dmpForm;
//	}

//	public User getUser(String userName) throws Exception {
//		return this.dmpService.getUser(userName);
//	}

//	private DMPForm refreshDmpForm(DMPForm dmpForm, DMP dmp) {
//		dmpForm.setDmp(dmp);
//		dmpForm.setId(String.valueOf(dmp.getId()));
//		try {
//			getDmpConversionService().processDMPTypes(dmpForm);
//			dmpForm.setDmpToolUsers(new ArrayList<DMPToolUser>(dmp.getAssignees()));
//
//			ArrayList<DMPQuestion> dmpQuestions = new ArrayList<DMPQuestion>(dmp.getQuestions());
//			for (int i = 0; i < dmpQuestions.size(); i++) {
//				DMPQuestion dmpQuestion = dmpQuestions.get(i);
//				getDmpConversionService().processQuestionResponse(dmpQuestion);
//				getDmpConversionService().processQuestionContent(dmpQuestion);
//				dmpQuestion.setQuestionOrder(i + 1 + "");
//			}
//			dmpForm.setQuestions(dmpQuestions);
//
//			if (dmp.getModifiedBy() != null) {
//				if (dmp.getModifiedBy().getChangeUser() != null) {
//					dmpForm.setModifiedBy(getUser(dmp.getModifiedBy().getChangeUser()).getFullName());
//				}
//			}
//
//			// sort assignees
//			ArrayList<DMPToolUser> assigneeList = new ArrayList<DMPToolUser>(dmp.getAssignees());
//			Collections.sort(assigneeList, new Comparator<DMPToolUser>() {
//				@Override
//				public int compare(DMPToolUser dmpToolUser1, DMPToolUser dmpToolUser2) {
//					return dmpToolUser1.getAppUser().getFullName()
//							.compareToIgnoreCase(dmpToolUser2.getAppUser().getFullName());
//				}
//			});
//
//			String dmpAssignees = "";
//			int count = 0;
//			for (DMPToolUser dmpToolUser : assigneeList) {
//				if (dmpToolUser.isAssigned()) {
//					if (count == 0) {
//						dmpAssignees = dmpAssignees + dmpToolUser.getAppUser().getFullName();
//					} else {
//						dmpAssignees = dmpAssignees + "; " + dmpToolUser.getAppUser().getFullName() + " ";
//					}
//					if (count > 1 && count % 6 == 0) {
//						dmpAssignees = dmpAssignees + "\n";
//					}
//					/**
//					 * REMOVED FOR BACKING OUT CCR 1056 CHANGES
//					 * dmpForm.setIsAssignee(true); dmpForm.setCanEdit(true);
//					 */
//					count++;
//				}
//			}
//			dmpForm.setDmpAssignees(dmpAssignees);
//
//		} catch (Exception e) {
//			Log.warn("error", e);
//			dmpForm.setModifiedBy(dmp.getModifiedBy().getChangeUser());
//			// logger.error("DMP modifiedBy not available for user: "
//			// + dmp.getModifiedBy().getChangeUser());
//		}
//		try {
//			if (dmp.getCreatedBy() != null) {
//				if (dmp.getCreatedBy().getChangeUser() != null) {
//					dmpForm.setCreatedBy(getUser(dmp.getCreatedBy().getChangeUser()).getFullName());
//				}
//			}
//		} catch (Exception e) {
//			Log.warn("error", e);
//			dmpForm.setCreatedBy(dmp.getCreatedBy().getChangeUser());
//			// logger.error("DMP createdBy not available for user: "
//			// + dmp.getCreatedBy().getChangeUser());
//		}
//		dmpForm.setHasComments(dmp.isHasComments());
//		return dmpForm;
//	}

//	public List<DMPSearchForm> getAllDmps() throws Exception {
//		List<DMPSearchForm> results = new ArrayList<DMPSearchForm>();
//		List<DMPSearch> rawResults = dmpService.getAllDmps();
//		for (DMPSearch dmp : rawResults) {
//			DMPSearchForm dmpForm = new DMPSearchForm();
//			dmpForm = this.refreshDmpSearchForm(dmpForm, dmp);
//			results.add(dmpForm);
//		}
//		return results;
//	}

//	private DMPSearchForm refreshDmpSearchForm(DMPSearchForm dmpForm, DMPSearch dmp) {
//		dmpForm.setDmp(dmp);
//		dmpForm.setId(String.valueOf(dmp.getId()));
//		getDmpConversionService().processDMPTypes(dmpForm);
//		String dmpAssignees = "";
//		dmpForm.setDmpAssignees(dmpAssignees);
//		dmpForm.setHasComments(dmp.isHasComments());
//
//		return dmpForm;
//
//	}

//	public List<DMPSearchForm> searchAllDmps(DMPSearchParameters dmpSearchParameters) throws Exception {
//		List<DMPSearchForm> results = new ArrayList<DMPSearchForm>();
//		List<DMPSearch> rawResults = dmpService.searchAllDmps(dmpSearchParameters);
//		for (DMPSearch dmp : rawResults) {
//			DMPSearchForm dmpForm = new DMPSearchForm();
//			dmpForm = this.refreshDmpSearchForm(dmpForm, dmp);
//			results.add(dmpForm);
//		}
//		return results;
//	}

//	public DMPForm getSelectedDmp(String dmpId) throws Exception {
//		DMPForm dmpForm = new DMPForm();
//		DMP dmp = dmpService.findDMPById(dmpId);
//		dmpForm = refreshDmpForm(dmpForm, dmp);
//		return dmpForm;
//	}

//	public DMPForm getSelectedDmp(String dmpId, String userId) throws Exception {
//		DMPForm dmpForm = new DMPForm();
//		DMP dmp = dmpService.findDMPById(dmpId);
//		ArrayList<DMPToolUser> utl = new ArrayList<DMPToolUser>(dmp.getAssignees());
//		dmpForm.setDmpToolUserReviewers(this.getDMPToolUserReviewers(utl));
//		dmpForm.setDmpReviewerNames(this.findDmpReviewerNames(dmpForm));
//		dmpForm = refreshDmpForm(dmpForm, dmp);
//		// set canEditComment property
//		boolean isReviewer = this.isUserInDMPReviewers(dmpForm, userId);
//		dmpForm.setIsReviewer(isReviewer);
//
//		/**
//		 * CCR 1056 NEXT TWO LINES ADDED BACK IN TO REVERT BACK TO PRE-1056
//		 */
//		boolean isAssignee = this.isUserInAssignees(utl, userId);
//		dmpForm.setIsAssignee(isAssignee);
//
//		if (dmp.getCreatedBy() != null && dmp.getCreatedBy().getChangeUser() != null) {
//			if (dmp.getCreatedBy().getChangeUser().equalsIgnoreCase(userId)) {
//				dmpForm.setIsAssignee(true);
//
//				/**
//				 * CCR 1056 REMOVED FOR REVERSION BACK TO PRE-1056
//				 * dmpForm.setCanEdit(true); return dmpForm;
//				 */
//			}
//		}
//
//		/**
//		 * CCR 1056 REMOVED FOR REVERSION BACK TO PRE-1056 boolean isAssignee =
//		 * this.isUserInAssignees(utl, userId);
//		 * dmpForm.setIsAssignee(isAssignee); dmpForm.setCanEdit(isAssignee);
//		 */
//		return dmpForm;
//	}

//	public DMPStandLibEntry getSelectedDmpSL(Long dmpSlId) throws Exception {
//		DMPStandLibEntry dmpStandLibEntry = new DMPStandLibEntry();
//		dmpStandLibEntry = dmpService.findDMPStanLibEntryById(dmpSlId);
//		getDmpConversionService().processDmpStandLibEntryTypes(dmpStandLibEntry);
//		return dmpStandLibEntry;
//	}

//	public List<DMPForm> getAdminViewMyDmps2(String userId) throws Exception {
//
//		List<DMPForm> results = new ArrayList<DMPForm>();
//		List<DMP> rawResults = dmpService.findAdminViewMyDmps(userId);
//		Collections.sort(rawResults, new Comparator()
//
//		{
//			public int compare(Object obj1, Object obj2) {
//				DMP dmp1 = (DMP) obj1;
//				DMP dmp2 = (DMP) obj2;
//				return (dmp1.getName().compareToIgnoreCase(dmp2.getName()));
//			}
//		});
//		// Collections.reverse(rawResults);
//		for (DMP dmp : rawResults) {
//			DMPForm dmpForm = new DMPForm();
//			dmpForm = this.refreshDmpForm(dmpForm, dmp);
//			dmpForm.setModifiedBy(dmp.getModifiedByName());
//			dmpForm.setModifiedDate(dmp.getModifiedOn().toString());
//			results.add(dmpForm);
//		}
//		return results;
//	}

//	public DMPForm saveDmpComments(DMPForm dmpForm) throws Exception {
//		DMPReview review = dmpForm.getSelectedDMPReview();
//		review = dmpService.saveDMPReview(review);
//		DMP dmp = dmpService.findDMPById(dmpForm.getId());
//		dmpForm.setDmp(dmp);
//		dmpForm = refreshDmpForm(dmpForm, dmp);
//		List<DMPReview> reviewList = dmpService.getDMPQuestionComments(dmpForm.getId(), review.getDmpContentId());
//		dmpForm.getSelectedQuestion().setReviewComments(new HashSet(reviewList));
//		dmpForm.setSelectedDMPReview(review);
//
//		return dmpForm;
//
//	}

//	public DMPForm deleteDmpComments(DMPForm dmpForm) throws Exception {
//		DMPReview review = dmpForm.getSelectedDMPReview();
//		review = dmpService.deleteDMPReview(review);
//		dmpForm.setSelectedDMPReview(review);
//		List<DMPReview> reviewList = dmpService.getDMPQuestionComments(dmpForm.getId(), review.getDmpContentId());
//		dmpForm.getSelectedQuestion().setReviewComments(new HashSet(reviewList));
//		return dmpForm;
//	}

//	public Boolean checkIfAlreadyDeployedToVendor(DMPForm deployedDMP, String vendor) {
//		return true;
//	}

//	public Boolean deployToVendor(DMPForm deployedDMP, String vendorName, byte[] byteme, String name) throws Exception {
//		EntityKey<DMP> entityKey = EntityKeyFactory.createEntityKey(new Long(deployedDMP.getId()), DMP.class);
//		DMP dmp = dmpService.getDMP(entityKey);
//		DMPVendorDeployment dmpVendorDeployment = new DMPVendorDeployment();
//		dmpVendorDeployment.setDeployedDate(new Date(System.currentTimeMillis()));
//		dmpVendorDeployment.setDmp(dmp);
//		Integer version = dmp.getVersion();
//		if (version != null) {
//			dmpVendorDeployment.setDmpVersion(dmp.getDmpVersion().toString());
//		}
//		dmpVendorDeployment.setFacilitator(dmp.getCreatedById());
//		dmpVendorDeployment.setStatusType(dmp.getDmpStatusType());
//		Vendor vendor = dmpService.getInventoryDAO().getVendor(vendorName);
//		dmpVendorDeployment.setVendor(vendor.getId());
//
//		dmpService.sendVendorMail(dmp, vendorName, byteme, name);
//		dmpService.saveDMPVendorDeployment(dmpVendorDeployment);
//		return true;
//	}

//	public Boolean isDmpAlreadyDeployedToVendor(DMPForm deployedDMP, String vendorName) throws Exception {
//		EntityKey<DMP> entityKey = EntityKeyFactory.createEntityKey(new Long(deployedDMP.getId()), DMP.class);
//		DMP dmp = dmpService.getDMP(entityKey);
//
//		return dmpService.checkIfAlreadyDeployedToVendor(dmp, vendorName);
//	}

//	public List<DMPReview> getDMPQuestionComments(String dmpId, String dmpContentId) throws Exception {
//		List<DMPReview> dmpReview = dmpService.getDMPQuestionComments(dmpId, dmpContentId);
//		return dmpReview;
//	}

//	public List<DmpAssignee> findDmpReviewers(DMPForm dmp) throws Exception {
//		List<DmpAssignee> dmpReviewers = new ArrayList<DmpAssignee>();
//		List<DMPToolUser> dmpToolUsers = dmpService.findDMPToolUsers(dmp.getId());
//		// List<DMPToolUser> dmpReviewerList =
//		// dmp.getDmpToolUserReviewers();
//		if (dmpToolUsers != null && dmpToolUsers.size() > 0) {
//			for (DMPToolUser dmpToolUser : dmpToolUsers) {
//				if (dmpToolUser.isReviewer()) {
//					UserForm userForm = securityController.getUser(dmpToolUser.getAppUser().getName());
//					if (userForm.getTelephoneNumber() == null)
//						userForm.setTelephoneNumber("");
//					if (userForm.getEmail() == null)
//						userForm.setEmail("");
//					if (userForm.getRegistrationStatus() == null) {
//						TermType tm = new TermType("", "");
//						userForm.setRegistrationStatus(tm);
//					}
//					DmpAssignee dmpReviewer = new DmpAssignee();
//					dmpReviewer.setDmpToolUserId(dmpToolUser.getId().toString());
//					dmpReviewer.setUser(dmpToolUser.getAppUser());
//					dmpReviewer.setUserForm(userForm);
//					dmpReviewer.setAssigned(dmpToolUser.isAssigned());
//					dmpReviewer.setReviewer(dmpToolUser.isReviewer());
//					dmpReviewers.add(dmpReviewer);
//				}
//			}
//		}
//
//		Collections.sort(dmpReviewers, new Comparator<DmpAssignee>() {
//			@Override
//			public int compare(DmpAssignee entry1, DmpAssignee entry2) {
//				String e1 = formatName(entry1.getUserForm()).toLowerCase();
//				String e2 = formatName(entry2.getUserForm()).toLowerCase();
//				return e1.compareTo(e2);
//			}
//		});
//
//		return dmpReviewers;
//	}

//	private List<DMPToolUser> getDMPToolUserReviewers(List<DMPToolUser> dmpToolUsers) throws Exception {
//		List<DMPToolUser> dmpReviewers = new ArrayList<DMPToolUser>();
//		if (dmpToolUsers != null && dmpToolUsers.size() > 0) {
//			for (DMPToolUser dmpToolUser : dmpToolUsers) {
//				if (dmpToolUser.isReviewer()) {
//					dmpReviewers.add(dmpToolUser);
//				}
//			}
//		}
//		return dmpReviewers;
//	}

//	private String findDmpReviewerNames(DMPForm dmp) throws Exception {
//		StringBuffer reviewersb = new StringBuffer();
//		final String delimiter = "; ";
//		List<DMPToolUser> dmpReviewerList = dmp.getDmpToolUserReviewers();
//		// sort the dmp reviwers
//		Collections.sort(dmpReviewerList, new Comparator<DMPToolUser>() {
//			@Override
//			public int compare(DMPToolUser dmpToolUser1, DMPToolUser dmpToolUser2) {
//				return dmpToolUser1.getAppUser().getFullName()
//						.compareToIgnoreCase(dmpToolUser2.getAppUser().getFullName());
//			}
//		});
//
//		int count = 0;
//		if (dmpReviewerList != null && dmpReviewerList.size() > 0) {
//			for (DMPToolUser reviewer : dmpReviewerList) {
//				if (reviewer.isReviewer()) {
//					if (count > 0) {
//						reviewersb.append(delimiter);
//					}
//					reviewersb.append(reviewer.getAppUser().getFullName());
//					if (count > 1 && count % 6 == 0) {
//						reviewersb.append("\n");
//					}
//					count++;
//				}
//			}
//		}
//		return reviewersb.toString();
//	}

//	public DMPForm assignDmpReviewer(DMPForm dmpForm) throws Exception {
//		List<DmpAssignee> dmpReviewers = dmpForm.getReviewers();
//		DMP dmp = dmpService.findDMPById(dmpForm.getId());
//		for (DmpAssignee dmpReviewer : dmpReviewers) {
//			if (dmpReviewer.isReviewer() && !dmpReviewer.isDisableNewUserReviewerAssignment()) {
//				DMPToolUser newReviewer = new DMPToolUser();
//				User assingedUser = dmpService.getUserByLoginId(dmpReviewer.getUserForm().getUserName());
//				newReviewer.setAppUser(assingedUser);
//				newReviewer.setReviewer(true);
//				newReviewer.setDmp(dmp);
//				dmpService.saveDMPToolUser(newReviewer, false);
//			}
//		}
//		dmp = dmpService.saveDMP(dmp);
//		dmp = dmpService.findDMPById(dmpForm.getId());
//		ArrayList<DMPToolUser> utl = new ArrayList<DMPToolUser>(dmp.getAssignees());
//		dmpForm.setDmpToolUserReviewers(this.getDMPToolUserReviewers(utl));
//		dmpForm.setDmpReviewerNames(this.findDmpReviewerNames(dmpForm));
//		dmpForm = this.refreshDmpForm(dmpForm, dmp);
//		return dmpForm;
//	}

//	public DMPForm unAssignDmpReviewer(DMPForm dmpForm) throws Exception {
//		ArrayList<DMPToolUser> utl = null;
//		DMP dmp = dmpService.findDMPById(dmpForm.getId());
//		utl = new ArrayList<DMPToolUser>(dmp.getAssignees());
//		List<DMPToolUser> reviewers = this.getDMPToolUserReviewers(utl);
//		List<DmpAssignee> dmpNonReviewers = dmpForm.getReviewers();
//		for (DMPToolUser potentialNonReviewer : reviewers) {
//			for (DmpAssignee dmpNonReviewer : dmpNonReviewers) {
//				if (dmpNonReviewer.isReviewer()) {
//					if (Long.parseLong(dmpNonReviewer.getDmpToolUserId()) == potentialNonReviewer.getId().longValue()) {
//						potentialNonReviewer.setReviewer(false);
//						dmpService.saveDMPToolUser(potentialNonReviewer, false);
//					}
//				}
//			}
//		}
//		dmp = dmpService.findDMPById(dmpForm.getId());
//		dmp = dmpService.saveDMP(dmp);
//		utl = new ArrayList<DMPToolUser>(dmp.getAssignees());
//		dmpForm.setDmpToolUserReviewers(this.getDMPToolUserReviewers(utl));
//		dmpForm.setDmpReviewerNames(this.findDmpReviewerNames(dmpForm));
//		dmpForm = refreshDmpForm(dmpForm, dmp);
//		return dmpForm;
//	}

//	private boolean isUserInDMPReviewers(DMPForm dmpForm, String userId) throws Exception {
//		boolean isIn = false;
//		if (userId != null) {
//			User loginUser = dmpService.getUserByLoginId(userId);
//			List<DMPToolUser> reviewers = dmpForm.getDmpToolUserReviewers();
//			for (DMPToolUser reviewer : reviewers) {
//				if (reviewer.getAppUser().getId().longValue() == loginUser.getId().longValue()) {
//					isIn = true;
//					break;
//				}
//			}
//		}
//		return isIn;
//	}

//	private boolean isUserInAssignees(ArrayList<DMPToolUser> utl, String userId) throws Exception {
//		boolean isIn = false;
//		if (userId != null) {
//			User loginUser = dmpService.getUserByLoginId(userId);
//			for (DMPToolUser tooluser : utl) {
//				if (tooluser.getAppUser().getId().longValue() == loginUser.getId().longValue()) {
//					if (tooluser.isAssigned()) {
//						isIn = true;
//					}
//					break;
//				}
//			}
//		}
//		return isIn;
//	}

//	private String formatName(UserForm userForm) {
//		if (userForm == null)
//			return "";
//		String firstName = userForm.getGivenName();
//		String middleName = userForm.getMiddleName();
//		String lastName = userForm.getFamilyName();
//		String fullName = "";
//		if (lastName != null && !StringUtils.isEmpty(lastName)) {
//			fullName = fullName + lastName;
//			if (firstName != null && !StringUtils.isEmpty(firstName)) {
//				fullName = fullName + ", " + firstName;
//			}
//			if (middleName != null && !StringUtils.isEmpty(middleName)) {
//				if (firstName == null || StringUtils.isEmpty(firstName)) {
//					fullName = fullName + ", " + middleName;
//				} else {
//					fullName = fullName + " " + middleName;
//				}
//			}
//		}
//		return fullName;
//	}
}
