package gov.va.med.ccht.controller;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.validation.ObjectError;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import gov.va.med.ccht.controller.validators.ManageUserSearchFormValidator;
import gov.va.med.ccht.model.User;
import gov.va.med.ccht.ui.model.UserForm;
import gov.va.med.fw.model.ldap.SearchCriteria;
import gov.va.med.fw.ui.model.TermType;

@Controller
// @SessionAttributes(value = { "command" })
public class ManageUserSearchController extends CommonCchtController {

	@Autowired
	private ManageUserSearchFormValidator validator;

	@RequestMapping(value = "/manageUsersSearch.html", method = RequestMethod.GET)
	public String showManageUser(@ModelAttribute("command") UserForm command, Model model) throws Exception {
		return "manageUsersSearch";
	}

	@RequestMapping(value = "/manageUsersSearch.html", method = { RequestMethod.GET }, params = { "Search" })
	public String showSelectedUser(@ModelAttribute("command") UserForm command, BindingResult result, Model model)
			throws Exception {

		//validator.validate(command.getFirstName(), command.getLastName(), command.getId(), result);
//		if (result.hasErrors()) {
//			
//			return "manageUsersSearch";
//		}

		SearchCriteria criteria = new SearchCriteria();

		// Build criteria object so we can search by the users input

		if (command.getId() != null && command.getId().length() > 0) {
			// User has opted to search by user id (vha...)
			criteria.setUserID(command.getId());
		} else {
			// User has opted to search by last name
			criteria.setLastName(command.getLastName());

			// User has also opted to further filter by first name.
			if (command.getFirstName() != null && command.getFirstName().length() > 0) {
				criteria.setFirstName(command.getFirstName());
			}
		}

		// Get a list of users accorting to criteria.
		List<User> cchtUsers = securityService.findAppUsers(criteria);
		
		
//		// Validate that users were found
//		validator.validateSearchResults(cchtUsers, result);
//		if (result.hasErrors()) {
//			return "manageUsersSearch";
//		}
		
		// Users have been found.
		// found users create UserForm object(s) to display.
		if (cchtUsers.size() > 1) {
			model.addAttribute("users", cchtUsers);
			return "userSearchResult";
		} else if (cchtUsers.size() == 1) {
			// One User Found
			User user = cchtUsers.get(0);

			// show edit page.
			return "redirect:" + basePath + "manageUsersEdit.html?userName=" + user.getUsername()
					+ "&fromPage=userSearch";
		}
		else if(cchtUsers == null || cchtUsers.size() < 1) {
			model.addAttribute("showNoRecordsError", true);
		}

		return "manageUsersSearch";
	}

}
