package gov.va.med.ccht.controller;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;

import gov.va.med.ccht.model.dmp.PatientSatSurveyReportParameters;
import gov.va.med.ccht.model.dmpreport.PSSQuestionManager;
import gov.va.med.ccht.model.dmpreport.SatisfactionSurveyQuestionResult;
import gov.va.med.ccht.service.dmpreport.SatisfactionSurveyResultService;
import gov.va.med.ccht.ui.common.AbstractController;

@Controller
public class SatisfactionSurveyReportController extends AbstractController {

	@Autowired
	private SatisfactionSurveyResultService satisfactionSurveyResultService;

	public List<SatisfactionSurveyQuestionResult> getSatisfactionSurveyReport(
			PatientSatSurveyReportParameters reportParams) throws Exception {
		List<SatisfactionSurveyQuestionResult> list = satisfactionSurveyResultService
				.findSatisfactionSurveyResultReport(reportParams);
		return list;
	}

	public PSSQuestionManager getQuestionsForReportVersion(Integer version) throws Exception {
		return satisfactionSurveyResultService.getQuestionsForReportVersion(version);
	}

}
