package gov.va.med.ccht.ui.common;

import gov.va.med.ccht.ui.model.UserPrincipalForm;

public class ClientSessionParameters {

	// All the values are define in minutes
	private Integer inactiveTimeout = 14;
	private Integer confirmationTimeout = 1;
	private Integer sessionTimeout = 60;
	private Integer inactiveCheckInterval = 1;
	private Integer serverCheckInterval = 5;
	private boolean showStackTrace = false;
	private String version = null;
	private UserPrincipalForm user = null;

	public ClientSessionParameters() {}
	
	public ClientSessionParameters(Integer inactiveTimeout, Integer confirmationTimeout, Integer sessionTimeout,
			Integer inactiveCheckInterval, Integer serverCheckInterval, boolean showStackTrace) {
		this.inactiveTimeout = inactiveTimeout;
		this.confirmationTimeout = confirmationTimeout;
		this.sessionTimeout = sessionTimeout;
		this.inactiveCheckInterval = inactiveCheckInterval;
		this.serverCheckInterval = serverCheckInterval;
		this.showStackTrace = showStackTrace;
	}

	/**
	 * @return the confirmationTimeout
	 */
	public Integer getConfirmationTimeout() {
		return confirmationTimeout;
	}

	/**
	 * @param confirmationTimeout
	 *            the confirmationTimeout to set
	 */
	public void setConfirmationTimeout(Integer confirmationTimeout) {
		if (confirmationTimeout != null && confirmationTimeout > 0)
			this.confirmationTimeout = confirmationTimeout;
	}

	/**
	 * @return the inactiveTimeout
	 */
	public Integer getInactiveTimeout() {
		return inactiveTimeout;
	}

	/**
	 * @param inactiveTimeout
	 *            the inactiveTimeout to set
	 */
	public void setInactiveTimeout(Integer inactiveTimeout) {
		if (inactiveTimeout != null && inactiveTimeout > 0)
			this.inactiveTimeout = inactiveTimeout;
	}

	/**
	 * @return the sessionTimeout
	 */
	public Integer getSessionTimeout() {
		return sessionTimeout;
	}

	/**
	 * @param sessionTimeout
	 *            the sessionTimeout to set
	 */
	public void setSessionTimeout(Integer sessionTimeout) {
		if (sessionTimeout != null && sessionTimeout > 0)
			this.sessionTimeout = sessionTimeout;
	}

	/**
	 * @return the inactiveCheckInterval
	 */
	public Integer getInactiveCheckInterval() {
		return inactiveCheckInterval;
	}

	/**
	 * @param inactiveCheckInterval
	 *            the inactiveCheckInterval to set
	 */
	public void setInactiveCheckInterval(Integer inactiveCheckInterval) {
		if (inactiveCheckInterval != null && inactiveCheckInterval > 0)
			this.inactiveCheckInterval = inactiveCheckInterval;
	}

	/**
	 * @return the serverCheckInterval
	 */
	public Integer getServerCheckInterval() {
		return serverCheckInterval;
	}

	/**
	 * @param serverCheckInterval
	 *            the serverCheckInterval to set
	 */
	public void setServerCheckInterval(Integer serverCheckInterval) {
		if (serverCheckInterval != null && serverCheckInterval > 0)
			this.serverCheckInterval = serverCheckInterval;
	}

	/**
	 * @return the showStackTrace
	 */
	public boolean isShowStackTrace() {
		return showStackTrace;
	}

	/**
	 * @param showStackTrace
	 *            the showStackTrace to set
	 */
	public void setShowStackTrace(boolean showStackTrace) {
		this.showStackTrace = showStackTrace;
	}

	public String getVersion() {
		return version;
	}

	public void setVersion(String version) {
		this.version = version;
	}

	public UserPrincipalForm getUser() {
		return user;
	}

	public void setUser(UserPrincipalForm user) {
		this.user = user;
	}
}
