<%@ include file="inc_header.jsp"%>

<%--Allow these to be set either in the model or in the tiles config - CPB --%>
<c:if test="${empty pageTitle}">
	<tiles:importAttribute name="pageTitle" scope="page" ignore="true" />
</c:if>

<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<meta http-equiv="X-UA-Compatible" content="IE=edge" />

<%@ include file="inc_common.jsp" %>
<title><c:out value="${pageTitle}" /></title>

</head>
<body>
	<div id="skip">
		<a href="#appTitleLink" aria-label="Skip to Page Content" title="Skip to Page Content">Skip to Page Content</a>
	</div>
	<div class="container">
		<header>
			<div class="pageBanner">
				<img src="images/ihta_banner.jpg"
					alt="Integrated Home TeleHealth Banner" tabindex="0" />
			</div>

			<div class="headerInfo">
				<h4 class="welcomeMessage" tabindex="0">
					Welcome: 
					<c:out value="${userDisplayName}" />
				</h4>
				<h4 class="piiMessage" tabindex="0">Do NOT enter any Personally
					Identifiable Information (PII) into this system!</h4>
				<a href="/ccht/logout.action"
					onClick="return(logoutConfirm()); return false;"
					class="headerLogOutLink" tabindex="0">Log Out</a> 				
				<a href="/ccht/help.html" target="_blank" tabindex="1">
					<img src="images/helpicon.gif" alt="Integrated Home Tele Health Help Will Open In A New New Window" class="headerHelpLink" tabindex="0" />
				</a>
			</div>

			<%@ include file="menu.jsp"%>
		</header>

		<div class="moduleContainer">
			<c:if test="${not empty pageTitle}">
				<a id="appTitleLink">
				<div class="moduleTitle">
					<h4>
						<c:out value="${pageTitle}" />
					</h4>
				</div>
				</a>
			</c:if>

			<%@ include file="inc_informationMessage.jsp" %>
		</div>

		<main role="main" style="margin-top: 10px;">
		<div style="min-height: 500px">
			<tiles:insertAttribute name="body" />
		</div>
		</main>
		<%@ include file="inc_countdownTimer.jsp" %>
		<footer>
			<jsp:include page="footer.jsp" />
		</footer>
	</div>
</body>
</html>