package gov.va.med.fw.controls
{
	import flash.events.KeyboardEvent;
	import flash.ui.Keyboard;
	
	import gov.va.med.fw.utils.AccessibilityDelegate;
	import gov.va.med.fw.utils.StringUtils;
	
	import mx.controls.Button;
	import mx.core.mx_internal;
	import mx.resources.ResourceManager;
	
	use namespace mx_internal;
	
	[AccessibilityClass(implementation="mx.accessibility.ButtonAccImpl")]
	
	public class Button extends mx.controls.Button
	{
		mx_internal static var createAccessibilityImplementation:Function;
		
		public function Button()
		{
			super();	
		}
		
		override protected function initializeAccessibility():void
		{
			if (gov.va.med.fw.controls.Button.createAccessibilityImplementation != null)
				gov.va.med.fw.controls.Button.createAccessibilityImplementation(this);
		}
		
		public var key:String = "";
		public var bundle:String = "";
		
		/**
		 *  If the label attribute is not given, uses bundle and key attributes to get 
		 *  the text value. 
		 */ 
		override public function get label():String {
			var string:String = super.label;
			if(StringUtils.isEmpty(string) && StringUtils.isNotEmpty(key) && StringUtils.isNotEmpty(bundle)) {
				super.label = string = ResourceManager.getInstance().getString(bundle,key);
			}
			return string;
		}
		
		/**
		 * Simulate ENTER key to SPACE key
		 */ 
		override protected function keyDownHandler(event:KeyboardEvent):void {
			if(event.keyCode == Keyboard.ENTER) {
				event.keyCode = Keyboard.SPACE;
			}
			super.keyDownHandler(event);
		}
		
		/**
		 * Simulate ENTER key to SPACE key
		 */
		override protected function keyUpHandler(event:KeyboardEvent):void {
			if (event.keyCode == Keyboard.ENTER) {
				event.keyCode = Keyboard.SPACE;
			}
			super.keyUpHandler(event);
		}	
		
	}
}

