package gov.va.med.fw.controls {
	
	import flash.accessibility.AccessibilityProperties;
	import flash.display.DisplayObject;
	import flash.events.FocusEvent;
	
	import gov.va.med.fw.utils.AccessibilityDelegate;
	
	import mx.accessibility.AccConst;
	import mx.controls.Text;
	import mx.core.mx_internal;
	import mx.managers.IFocusManagerComponent;
	
	use namespace mx_internal;
	
	[AccessibilityClass(implementation="mx.accessibility.LinkButtonAccImpl")]
	
	public class Text extends mx.controls.Text implements IFocusManagerComponent {
		
		mx_internal static var createAccessibilityImplementation:Function;
		
		public function Text() {
			super();
			tabChildren = true; 
			tabEnabled = true;
			selectable = true;
			this.addEventListener(FocusEvent.FOCUS_IN, onFocus); 			
			this.accessibilityProperties = new AccessibilityProperties();
		}
		
		public function onFocus(event:FocusEvent):void {
			accessibilityDescription = this.text;
			accessibilityName = this.text;
			if(parent!=null && (parent is FormItem)) {
				var fi:FormItem = FormItem(parent);
				if(fi.required || (fi.label!=null && fi.label.length>0)) {
					var additionalAccessibilityText = (fi.required==true?"required ":"") + "field " + (fi.label==null?"":fi.label);
					accessibilityDescription = additionalAccessibilityText + this.text;
					accessibilityName = additionalAccessibilityText + this.text;
				} 
			}	
			AccessibilityDelegate.updateProperties();
			AccessibilityDelegate.sendEvent(DisplayObject(this.textField),0,0x8005,true);
		}
		
		override protected function initializeAccessibility():void {
			if (createAccessibilityImplementation != null)
				createAccessibilityImplementation(this);
		}
	}
}