package gov.va.med.fw.io;

/**
 * Interface defining methods to add a suffix dynamically to any file name.
 * 
 * @author Rajiv Patnaik Created on Mar 1, 2006
 * @version 1.0
 * 
 *          Copyriight 2006 VHA. All rights reserved
 */
public interface FileNameAppender {
	/**
	 * Method to add a suffix to an existing filename/location. For example,
	 * appending a date and file number - fileName<310305nnnn>
	 * 
	 * @param obj
	 *            Any data needed to create the suffix.
	 * @return the file name suffix
	 */
	public String getFileNameSuffix(Object obj);
}
