/********************************************************************
 * Copyriight 2006 VHA. All rights reserved
 ********************************************************************/

package gov.va.med.fw.scheduling;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.scheduling.quartz.LocalDataSourceJobStore;

/**
 * This custom JobStore is necessary to reduce the contention on QRTZ_LOCKS
 * table in trigger/job insertions and misfire handler thread.
 * 
 * Created Nov 2, 2006 4:05:36 PM
 * 
 * @author DNS   BOHMEG
 */
public class PersistentJobStore extends LocalDataSourceJobStore {
	protected final Log logger = LogFactory.getLog(getClass());

	public PersistentJobStore() {
		super.setLockOnInsert(false);
	}
}
