/********************************************************************
 * Copyriight 2005 VHA. All rights reserved
 ********************************************************************/
package gov.va.med.fw.service.trigger;

import java.io.Serializable;

import org.apache.commons.lang.enums.Enum;

/**
 * Log4j Trigger Event class.
 * 
 * @author Venky Kullampalle
 */
public class Log4jTriggerEvent extends TriggerEvent {

	private TriggerEventType triggerEventType;

	public static final TriggerEventType UPDATE = new TriggerEventType("UPDATE");

	public static final TriggerEventType RESET_TO_DEFAULT = new TriggerEventType("RESET_TO_DEFAULT");

	private static final long serialVersionUID = 5959623688950965924L;

	/**
	 * 
	 * @param name
	 * @param payload
	 * @param triggerIdentity
	 * @param triggerEventType
	 */
	public Log4jTriggerEvent(String name, Serializable payload, TriggerIdentity triggerIdentity,
			TriggerEventType triggerEventType) {
		super(name, payload, triggerIdentity);
		this.triggerEventType = triggerEventType;
	}

	public TriggerEventType getTriggerEventType() {
		return triggerEventType;
	}

	public void setTriggerEventType(TriggerEventType triggerEventType) {
		this.triggerEventType = triggerEventType;
	}

	public static class TriggerEventType extends Enum {

		private static final long serialVersionUID = -5803082167530880674L;

		protected TriggerEventType(String name) {
			super(name);
		}

	}

}
