<%@ include file="inc_header.jsp"%>

<link rel="stylesheet" href="css/managescheduledjobs.css" />
<link rel="stylesheet" href="css/viewmyqir.css" />

<script type="text/javascript">
	function printQIR() {
		var selected = $('#selectedQIR').val();
		if (selected != null) {
			window.open('qir.action?qirId=' + selected);
		}
	}

	$(function() {
		var table = $('#currentQIRS').DataTable({
			scrollY : "250px",
			paging : true,
			autowidth : true,
			searching : false,
			select : 'single',
			order : [ [ 1, "desc" ] ]
		})

		$('#currentQIRS tbody').on('click', 'tr', function() {
			var isSelected = $(this).hasClass('selected')
			var data = table.row(this).data()
			$('#selectedQIR').val(isSelected ? data[1] : '')
			refreshButtons()
		})
	})

	function refreshButtons() {
		var selectedVal = $('#selectedQIR').val()
		var existingVal = selectedVal != ''
		$('#edit').css("display", existingVal ? "inline-block" : "none")
		$('#edit')
			.attr(
					'value',
					qirMap[selectedVal].statusCode == "Withdrawn" || qirMap[selectedVal].statusCode == "Closed" ? "View"
							: "Edit")
		$('#pdf').css("display", existingVal ? "inline-block" : "none");
		// $('#excel').css("display", existingVal ? "inline-block" : "none");
	}
	
	var qirMap = new Object()
	<c:forEach items="${qirList}" var="qir">
	qirMap['${qir.id}'] = {
		statusCode : "<c:out value="${qir.qirStatusType}" />"
	}
	</c:forEach>
</script>

<form:form method="get" action="manageQirs.html" commandName="command">
	<form:errors path="*" cssClass="errorBlock" element="div" />
	<table class="stripe dt-head-left dt-body-left hover cell-border"
		id="currentQIRS">
		<thead>
			<tr>
				<th>Status</th>
				<th>TN</th>
				<th><img src="images/PaperClip_Black.png" alt="Attachment" />
				</th>
				<th>Headline</th>
				<th>Submitted Date</th>
				<th>Submitted By</th>
				<th>Facility</th>
				<th>Vendor</th>
				<th>Type</th>
			</tr>
		</thead>
		<tbody>
			<c:forEach items="${qirList}" var="qir">
				<tr>
					<td tabindex="0"><c:out value="${qir.qirStatusType}" /></td>
					<td tabindex="0"><c:out value="${qir.id}" /></td>
					<td tabindex="0"><c:if test="${qir.hasAttachments}">
							<img src="images/PaperClip_Black.png" alt="True" />
						</c:if></td>
					<td tabindex="0"><c:out value="${qir.headline}" /></td>
					<td tabindex="0"><c:out value="${qir.submittedDateAsString}" /></td>
					<td tabindex="0"><c:out value="${qir.submittedByName}" /></td>
					<td tabindex="0"><c:out value="${qir.facilityNumAndName}" />
					</td>
					<td tabindex="0"><c:out value="${qir.vendor}" /></td>
					<td tabindex="0"><c:out value="${qir.qirType}" /></td>
				</tr>
			</c:forEach>
		</tbody>
	</table>
	<input type="submit" class="submitAnchor button" id="edit" value="Edit" name="Edit"
		style="display: none" />
	<input type="button" class="submitAnchor button" id="pdf" value="PDF" name="PDF"
		onclick="printQIR()" tabIndex="0" />
	<input type="submit" class="submitAnchor button" id="refresh" value="Refresh"
		name="Refresh" tabIndex="0" />
	<input type="button" class="submitAnchor button" id="cancel" value="Cancel"
		name="Cancel" onclick="javascript:document.location.href='home.html'" tabIndex="0" />
	<input id="selectedQIR" class="submitAnchor" name="selectedQIR" type="hidden" value=" "
		path="selectedQIR" />
</form:form>