<%@ include file="inc_header.jsp"%>

<link rel="stylesheet" href="css/editqir.css">

<script type="text/javascript">
	var isReadOnly = <c:out value="${command.readOnly}" default="false" />
	var isVendor = <c:out value="${isVendor}" default="false" />
	var qirStatusTypeCode = "<c:out value="${command.qirStatusType.value}" />"

	function printQIR() {
		var selected = $('#selectedQIR').val();
		if (selected != null)
			window.open('qir.action?qirId=' + selected);
	}

	function confirmCancel() {
		return confirm("All unsaved data will be lost. Do you still want to cancel?")
	}

	function confirmWithdraw() {
		return confirm("Withdraw QIR. This QIR will no longer be available for processing. Do you want to withdraw it?")
	}

	function stripLastCharacter(arg, legalLength) {
		var length = arg.length;
		var retVal = arg.slice(0, (legalLength));

		return retVal;
	}

	$(function() {
		if (!isReadOnly) {
			$(".editButton").show()
		} else {
			disableAttachmentTable()
			$(".editField").prop('disabled', true)
		}

		$("#recAndRemarksArea").html("");
		$("#recAndRemarksHistoryArea").prop("disabled", true);

		$("#editQirContainer").tabs({
			heightStyle : "content"
		});

		$("#isDmpIssueDropDown").change(function() {
			showDmpIssueTypeContainer();
		});

		$('#complaintArea').on('keyup', function(event) {
			var length = $("#complaintArea").val().length;

			if (length > 2000) {
				var currentMessage = $("#complaintArea").val();
				var strippedMessage = stripLastCharacter(currentMessage, 2000);
				$("#complaintArea").val(strippedMessage);
				length = $("#complaintArea").val().length;
			}
			var message = length + " of 2000 characters used.";

			$("#causeOfComplaintMessage").text(message);
		});

		$('#recAndRemarksArea').on('keyup', function(event) {
			var length = $("#recAndRemarksArea").val().length;

			if (length > 2000) {
				var currentMessage = $("#recAndRemarksArea").val();
				var strippedMessage = stripLastCharacter(currentMessage, 2000);
				$("#recAndRemarksArea").val(strippedMessage);
				length = $("#recAndRemarksArea").val().length;
			}
			var message = length + " of 2000 characters used.";

			$("#recommendationsMessage").text(message);
		});

		$('#vendorActions').on('keyup', function(event) {
			var length = $("#vendorActions").val().length;

			if (length > 2000) {
				var currentMessage = $("#vendorActions").val();
				var strippedMessage = stripLastCharacter(currentMessage, 2000);
				$("#vendorActions").val(strippedMessage);
				length = $("#vendorActions").val().length;
			}
			var message = length + " of 2000 characters used.";

			$("#vendorActionsMessageCount").text(message);
		});

		// Call to initialize according to actual isDmpIssue value
		// for selected QIR
		showDmpIssueTypeContainer()

		if (isVendor && qirStatusTypeCode == '2' /* Approved */) {
			$("#editQirContainer").tabs("option", "active", 2)
		}
	});

	function showDmpIssueTypeContainer() {
		if ($("#isDmpIssueDropDown").val() === "Y") {
			$("#dmpQirTypeDropDown").css('display', 'inline');
			$("#dmpIssueTypeContainer .required").css('display', 'inline');
		} else {
			$("#dmpQirTypeDropDown").css('display', 'none');
			$("#dmpQirTypeDropDown").val("-1");
			$("#dmpIssueTypeContainer .required").css('display', 'none');
		}
	}
</script>

<form:form method="post" action="editQir.html"
	enctype="multipart/form-data">

	<form:errors path="*" cssClass="errorBlock" id="errorBlock"
		element="div" tabIndex="0">
	</form:errors>
	<p id="title">
		<c:out value="${title}" />
	</p>
	<div id="editQirContainer">
		<ul>
			<li><a href="#summaryTab">Summary</a></li>
			<li><a href="#recAndRemarksTab">Recommendations And Remarks</a></li>
			<li><a href="#vendorActionsTab">Vendor Actions</a></li>
			<li><a href="#attachmentsTab">Attachments</a></li>
		</ul>

		<div id="summaryTab">
			<table>
				<tr valign="top" id="statusContainer">
					<td align="right" class="fieldLabel"><h4 tabindex="0">Status:</h4>
						<span class="invisibleRequiredFor508">*</span></td>
					<td><h2 class="required">*</h2></td>
					<td><h4 id="value" tabindex="0">
							<c:out value="${command.qirStatusType.label}" />
						</h4></td>
				</tr>
				<tr valign="top" id="tnContainer">
					<td align="right" class="fieldLabel"><h4 tabindex="0">Tracking
							Number:</h4></td>
					<td></td>
					<td><h4 id="value" tabindex="0">
							<c:out value="${command.id}" />
						</h4> <input id="selectedQIR" name="selectedQIR" type="hidden"
						value="${command.id}" path="selectedQIR" class="editField" /></td>
				</tr>
				<tr valign="top" id="headlineContainer">
					<td align="right" class="fieldLabel"><h4 tabindex="0">Headline:</h4></td>
					<td></td>
					<td><h4 id="value" tabindex="0">
							<c:out value="${command.headline}" />
						</h4></td>
				</tr>
				<tr valign="top" id="submittedDateContainer">
					<td align="right" class="fieldLabel"><h4 tabindex="0">Submitted
							Date:</h4></td>
					<td></td>
					<td><h4 id="value" tabindex="0">
							<c:out value="${command.submittedDateAsString}" />
						</h4></td>
				</tr>
				<tr valign="top" id="submittedByContainer">
					<td align="right" class="fieldLabel"><h4 tabindex="0">Submitted
							By:</h4></td>
					<td></td>
					<td><h4 id="value" tabindex="0">
							<c:out value="${command.submittedByName}" />
						</h4></td>
				</tr>
				<tr valign="top" id="facilityContainer">
					<td align="right" class="fieldLabel"><h4 tabindex="0">Facility:</h4></td>
					<td></td>
					<td><h4 id="value" tabindex="0">
							<c:out value="${command.facilityNumAndName}" />
						</h4></td>
				</tr>
				<tr valign="top" id="vendorContainer">
					<td align="right" class="fieldLabel"><h4 tabindex="0">Vendor:</h4></td>
					<td></td>
					<td><h4 id="value" tabindex="0">
							<c:out value="${command.vendor.label}" />
						</h4></td>
				</tr>
				<tr valign="top">
					<td align="right" class="fieldLabel"><h4 tabindex="0">Type
							of Complaint:</h4></td>
					<td></td>
					<td><h4 id="value" tabindex="0">
							<c:out value="${command.qirType.label}" />
						</h4></td>
				</tr>
				<tr valign="top" id="isDmpIssueContainer">
					<td align="right" class="fieldLabel"><h4 tabindex="0">DMP
							Issue:</h4> <span class="invisibleRequiredFor508">*</span></td>
					<td><h2 class="required">*</h2></td>
					<td><c:choose>
							<c:when test="${canEditIsDmpIssue}">
								<form:select path="isDmpIssue" id="isDmpIssueDropDown"
									cssClass="editField">
									<form:option value="S" label="Select" />
									<form:option value="Y" label="Yes" />
									<form:option value="N" label="No" />
								</form:select>
							</c:when>
							<c:otherwise>
								<c:if test="${command.isDmpIssue == 'N'}">
									<h4 id="value" tabindex="0">No</h4>
								</c:if>

								<c:if test="${command.isDmpIssue == 'Y'}">
									<h4 id="value" tabindex="0">Yes</h4>
								</c:if>
							</c:otherwise>
						</c:choose></td>
				</tr>
				<tr valign="top" id="dmpIssueTypeContainer">
					<td align="right" class="fieldLabel"><h4 tabindex="0">DMP
							Issue Type:</h4> <span class="invisibleRequiredFor508">*</span></td>
					<td><h2 class="required">*</h2></td>
					<td><c:if test="${canEditIsDmpIssue}">
							<form:select path="selectedDmpQirTypeId" id="dmpQirTypeDropDown"
								cssClass="editField">
								<form:option value="-1" label="Select" />
								<form:options items="${command.dmpQirTypes}" />
							</form:select>
						</c:if></td>
				</tr>
				<tr valign="top" id="orderNumberContainer">
					<td align="right" class="fieldLabel"><h4 tabindex="0">Contract
							or Purchase Order Number:</h4></td>
					<td></td>
					<td><h4 id="value" tabindex="0">
							<c:out value="${command.purchaseOrderNumber}" />
						</h4></td>
				</tr>
				<tr valign="top" id="deviceModelContainer">
					<td align="right" class="fieldLabel"><h4 tabindex="0">Device
							Model:</h4></td>
					<td></td>
					<td><h4 id="value" tabindex="0">
							<c:out value="${command.deviceType.label}" />
						</h4></td>
				</tr>
				<tr valign="top" id="serialNumberContainer">
					<td align="right" class="fieldLabel"><h4 tabindex="0">Serial
							Number:</h4></td>
					<td></td>
					<td><h4 id="value" tabindex="0">
							<c:out value="${command.serialNumber}" />
						</h4></td>
				</tr>
				<tr valign="top" id="complaintContainer">

					<c:choose>
						<c:when test="${isVendor}">
							<td align="right" class="fieldLabel"><h4 tabindex="0">Cause
									of Complaint:</h4></td>
							<td></td>
							<td><form:textarea id="complaintArea" path="complaint"
									rows="4" cols="75" disabled="true" cssClass="editField" />
								<p id="causeOfComplaintMessage"></p></td>
						</c:when>
						<c:otherwise>
							<td align="right" class="fieldLabel"><h4 tabindex="0">Cause
									of Complaint:</h4> <span class="invisibleRequiredFor508">*</span></td>
							<td><h2 class="required">*</h2></td>
							<td><form:textarea id="complaintArea" path="complaint"
									rows="4" cols="75" disabled="false" cssClass="editField" />
								<p id="causeOfComplaintMessage"></p></td>
						</c:otherwise>
					</c:choose>
				</tr>
			</table>
		</div>
		<div id="recAndRemarksTab">
			<table>
				<c:if test="${!isVendor}">
					<tr valign="top">
						<td align="right" class="fieldLabel"><h4 tabindex="0">Recommendations
								And Remarks:</h4></td>
						<td></td>
						<td><form:textarea id="recAndRemarksArea" path="remarks"
								rows="10" cols="75" cssClass="editField" />
							<p id="recommendationsMessage"></p></td>
					</tr>
				</c:if>
				<tr valign="top">
					<td align="right" class="fieldLabel"><h4 tabindex="0">Recommendations
							And Remarks History:</h4></td>
					<td></td>
					<td><form:textarea id="recAndRemarksHistoryArea"
							path="remarksHistory" rows="10" cols="75" cssClass="editField" /></td>
				</tr>
			</table>
		</div>
		<div id="vendorActionsTab">
			<table>
				<c:if test="${showVendorResponseDueDate}">
					<tr valign="top">
						<td align="right" class="fieldLabel"><h4 tabindex="0"
								style="color: Green;">Vendor Response Due:</h4></td>
						<td></td>
						<td><h4 id="value" tabindex="0" style="color: Green;">
								<c:out value="${vendorResponseDueDateAsString}" />
							</h4></td>
					</tr>
				</c:if>
				<c:if test="${isVendor}">
					<tr valign="top" id="vendorActionsContainer">
						<td align="right" class="fieldLabel"><h4 tabindex="0">Vendor
								Actions:</h4></td>
						<td><h2 class="required">*</h2></td>
						<td><form:textarea id="vendorActions" path="vendorActions"
								rows="10" cols="75" cssClass="editField" />
							<p id="vendorActionsMessageCount"></p></td>
					</tr>
				</c:if>
				<tr valign="top" id="vendorActionsHistoryContainer">
					<td align="right" class="fieldLabel"><h4 tabindex="0">Vendor
							Actions History:</h4></td>
					<td></td>
					<td><form:textarea id="vendorActionsHistory"
							path="vendorActionsHistory" rows="10" cols="75" disabled="true"
							cssClass="editField" /></td>
				</tr>
			</table>
		</div>
		<div id="attachmentsTab">
			<div id="informationMessageContainer">
				<h5 id="informationMessage" tabindex="0">The total size of all
					attachments should not exceed 5 MB.</h5>
			</div>
			<div id="attachmentsContainer" style="display: inline-block">
				<c:set var="attachmentTableInitialValues"
					value="${command.attachments}" scope="request" />
				<jsp:include page="inc_attachmentTable.jsp">
					<jsp:param name="showDelete" value="false" />
				</jsp:include>
			</div>
		</div>
	</div>

	<div id="buttonContainer">
		<input type="submit" class="submitAnchor button editButton" id="Update"
			value="Update" name="${command.updateButtonName}" />

		<c:if test="${canApproveQIR}">
			<input type="submit" class="submitAnchor button editButton" id="Approve"
				value="Approve" name="Approve" />
		</c:if>
		<c:if test="${canCloseQIR}">
			<input type="submit" class="submitAnchor button editButton" id="Close"
				value="Close" name="Close" />
		</c:if>
		<c:if test="${canReplyToQIR}">
			<input type="submit" class="submitAnchor button editButton" id="Reply"
				value="Reply" name="Reply" />
		</c:if>
		<c:if test="${canWithdrawQIR}">
			<input type="submit" class="submitAnchor button editButton" id="Withdraw"
				value="Withdraw" name="Withdraw"
				onclick="return(confirmWithdraw());" />
		</c:if>
		<input type="button" class="submitAnchor button" id="pdf" value="PDF" name="PDF"
			onclick="printQIR()" /> <input type="button" class="submitAnchor button"
			value="Cancel"
			onclick="javascript:document.location.href='${command.cancelHref}'" />
	</div>
</form:form>

