<%@ include file="inc_header.jsp"%>

<link rel="stylesheet" href="css/managescheduledjobs.css" />
<script type="text/javascript" src="scripts/manageScheduledJobs.js"></script>

<style>
	.statisticsButtonClass {
		display:none;
	}
</style>

<div id="scheduledJobTabContainer">
	<ul>
		<li><a href="#managementTab">Management</a></li>
		<li><a href="#activeTab">Active</a></li>
	</ul>
	<div id="managementTab">
		<section style="margin-top: 10px">
			<table class="stripe dt-head-left dt-body-left hover cell-border"
				id="currentJobs" style="vertical-align:top">
				<thead>
					<tr>
						<th>Job Name</th>
						<th>Description</th>
						<th>Schedule</th>
						<th>Next Scheduled Date/Time</th>
						<th>Scheduled Job Status</th>
					</tr>
				</thead>
				<tbody>
				</tbody>
			</table>
			<button type="button" id="execute"
				onclick="javascript:submitJobExecution()" />
			Execute
			</button>
			<button type="button" id="config"
				onclick="javascript:popupConfigEdit()">Config</button>
			<button type="button" id="schedule"
				onclick="javascript:popupScheduleEdit()">Schedule</button>
			<button type="button" id="history"
				onclick="javascript:popupHistory()">History</button>
			<button type="button" id="resumeAll" onclick="javascript:submitResumeAll()">Resume All</button>
			<button type="button" id="pauseAll" onclick="javascript:submitPauseAll()">Pause All</button>
			<button type="button" id="cancel" onclick="document.location.href='home.html'">Cancel</button>
		</section>
	</div>
	<div id="activeTab">
		<section style="margin-top: 10px"></section>
		<table class="stripe dt-head-left dt-body-left hover cell-border"
				id="activeJobs" style="vertical-align:top">
				<thead>
					<tr>
						<th>Job Name</th>
						<th>Start Date/Time</th>
						<th>Run By</th>
						<th>Status</th>
					</tr>
				</thead>
				<tbody>
				</tbody>
			</table>
			<button type="button" id="refreshActive"
				onclick="javascript:refreshActiveJobs()" />
			Refresh
			</button>
			<button type="button" id="cancelActive"
				onclick="document.location.href='home.html'">Cancel</button>
	</div>

</div>

<div id="configFieldsWrapper" style="display: none"
	title="Config Scheduled Job">
	<table>
		<tr>
			<td align="right" nowrap>Job Name:</td>
			<td width="10px">&nbsp;</td>
			<td><span id="configJobName"></span> <input type="hidden"
				id="configJobNameInput" /> <input type="hidden"
				id="configGroupName" /></td>
		</tr>
		<tr>
			<td align="right" nowrap>Description:</td>
			<td width="10px">&nbsp;</td>
			<td><span id="configJobDescription"></span></td>
		</tr>
		<tr>
			<td align="right" nowrap>Next Scheduled Fire Time:</td>
			<td width="10px">&nbsp;</td>
			<td><span id="configJobNextFireTime"></span></td>
		</tr>
		<tr>
			<td align="right" nowrap>Scheduled Job Status:</td>
			<td width="10px">&nbsp;</td>
			<td><span id="configJobExistingStatus"></span> <input
				type="hidden" id="configJobPreviousStatus" /></td>
		</tr>
		<tr valign="top">
			<td align="right" nowrap>E-mail Notification List:</td>
			<td width="10px">&nbsp;</td>
			<td>To enter multiple emails, separate each address with a comma
				(,).<br> <textarea id="configJobEmails" rows="4" cols="50"></textarea>
			</td>
		</tr>
		<tr>
			<td align="right" nowrap>Job Status:</td>
			<td width="10px">&nbsp;</td>
			<td><select id="configJobStatus">
					<c:forEach items="${allJobStatuses}" var="status">
						<option value="${status}"><c:out value="${status}" /></option>
					</c:forEach>
			</select></td>
		</tr>
	</table>
</div>

<div id="scheduleFieldsWrapper" style="display: none"
	title="Reschedule Scheduled Job">
	<table>
		<tr>
			<td align="right" nowrap>Job Name:</td>
			<td width="10px">&nbsp;</td>
			<td><span id="scheduleJobName"></span></td>
		</tr>
		<tr>
			<td align="right" nowrap>Description:</td>
			<td width="10px">&nbsp;</td>
			<td><span id="scheduleJobDescription"></span></td>
		</tr>
		<tr>
			<td align="right" nowrap>Next Scheduled Fire Time:</td>
			<td width="10px">&nbsp;</td>
			<td><span id="scheduleJobNextFireTime"></span></td>
		</tr>
		<tr>
			<td align="right" nowrap>Scheduled Job Status:</td>
			<td width="10px">&nbsp;</td>
			<td><span id="scheduleJobExistingStatus"></span></td>
		</tr>
		<tr valign="top">
			<td align="right" nowrap>Job Schedule:</td>
			<td width="10px">&nbsp;</td>
			<td><span id="scheduleJobScheduleDescriptionSpan"></span>
				<button type="button" id="scheduleJobChange"
					onclick="javascript:popupScheduleChange()">Change</button></td>
		</tr>
	</table>
	<%-- Populated when popping up this dialog --%>
	<input type="hidden" id="scheduleJobNameInput" /> <input type="hidden"
		id="scheduleGroupNameInput" /> <input type="hidden"
		id="scheduleTriggerNameInput" /> <input type="hidden"
		id="scheduleTriggerGroupInput" />
	<%-- Populated when popping up this dialog and also updated when changing the schedule via the popup below --%>
	<input type="hidden" id="scheduleJobCronInput" /> <input type="hidden"
		id="scheduleJobScheduleDescriptionInput" /> <input type="hidden"
		id="scheduleJobScheduleParamsCSV" />
</div>

<div id="scheduleChangeWrapper" style="display: none" title="Schedule">
	<table>
		<tr>
			<td align="right" nowrap>Run Frequency:</td>
			<td width="10px">&nbsp;</td>
			<td><select id="scheduleChangeFrequency">
					<c:forEach items="${allRunFrequencies}" var="runFrequency">
						<option value="${runFrequency.code}"><c:out
								value="${runFrequency.name}" /></option>
					</c:forEach>
			</select></td>
		</tr>
		<tr valign="top">
			<td align="right" nowrap>Day:</td>
			<td width="10px">&nbsp;</td>
			<td>
				<div class="scheduleTypeFields" id="dailyWeeklyOptions"
					style="display: none">
					<input type="radio" name="scheduleType" value="1"
						style="display: none" />
					<%-- ScheduleType.WEEK_DAY --%>
					<table>
						<%-- Don't feel like trying to make this DB-driven right now - CPB --%>
						<tr>
							<td><input type="checkbox" name="dailyWeeklyOptions"
								value="1"> Monday</td>
							<td><input type="checkbox" name="dailyWeeklyOptions"
								value="2"> Tuesday</td>
							<td><input type="checkbox" name="dailyWeeklyOptions"
								value="3"> Wednesday</td>
						</tr>
						<tr>
							<td><input type="checkbox" name="dailyWeeklyOptions"
								value="4"> Thursday</td>
							<td><input type="checkbox" name="dailyWeeklyOptions"
								value="5"> Friday</td>
							<td><input type="checkbox" name="dailyWeeklyOptions"
								value="6"> Saturday</td>
						</tr>
						<tr>
							<td><input type="checkbox" name="dailyWeeklyOptions"
								value="7"> Sunday</td>
							<td>&nbsp;</td>
							<td>&nbsp;</td>
						</tr>
					</table>
					<input type="hidden" id="scheduleFormDaysOfWeekCSVInput" />
				</div>
				<div class="scheduleTypeFields" id="monthlyOptions"
					style="display: none">
					<table>
						<tr>
							<td><input type="radio" name="scheduleType" value="2">
							<%-- ScheduleType.DAY_OF_MONTH --%> The <select
								id="relativeDayOfMonthValue">
									<option value="1">first</option>
									<option value="2">last</option>
									<option value="3">15th</option>
							</select> day of every month</td>
						</tr>
						<tr>
							<td><input type="radio" name="scheduleType" value="4">
							<%-- ScheduleType.WEEK_DAY --%> The <select id="weekOfMonth">
									<c:forEach items="${allWeekOfMonthTypes}" var="type">
										<option value="${type.code}"><c:out
												value="${type.name}" /></option>
									</c:forEach>
							</select> <select id="dayOfWeek">
									<c:forEach items="${allDayOfWeekTypes}" var="type">
										<option value="${type.code}"><c:out
												value="${type.name}" /></option>
									</c:forEach>
							</select> of every month</td>
						</tr>
					</table>
				</div>
				<div class="scheduleTypeFields" id="quarterlyOptions"
					style="display: none">
					<input type="radio" name="scheduleType" value="3"
						style="display: none" />
					<%-- ScheduleType.DAY_OF_QUARTER --%>
					<table>
						<tr>
							<td>The <select id="quarterlyDate">
									<option value="1">first</option>
									<option value="2">last</option>
							</select> day of every quarter
							</td>
						</tr>
					</table>
				</div>
				<div class="scheduleTypeFields" id="yearlyOptions"
					style="display: none">
					<table>
						<tr>
							<td><input type="radio" name="scheduleType" value="6">
							<%-- ScheduleType.MONTH_DAY --%> Every <select id="yearlyMonth">
									<c:forEach items="${allMonths}" var="month">
										<option value="${month.code}"><c:out
												value="${month.name}" /></option>
									</c:forEach>
							</select> on day <input type="text" id="yearlyMonthFixedDay" size="4" />
								of the month</td>
						</tr>
						<tr>
							<td><input type="radio" name="scheduleType" value="5">
							<%-- ScheduleType.WEEK_DAY_MONTH --%> The <select
								id="yearlyWeekOfMonth">
									<option value="1">first</option>
									<option value="2">second</option>
									<option value="3">third</option>
									<option value="4">fourth</option>
									<option value="5">last</option>
							</select> <select id="yearlyDayOfWeek">
									<c:forEach items="${allDayOfWeekTypes}" var="type">
										<option value="${type.code}"><c:out
												value="${type.name}" /></option>
									</c:forEach>
							</select> of <select id="yearlyRelativeMonth">
									<c:forEach items="${allMonths}" var="month">
										<option value="${month.code}"><c:out
												value="${month.name}" /></option>
									</c:forEach>
							</select></td>
						</tr>
					</table>
				</div>
				<div class="scheduleTypeFields" id="otherOptions"
					style="display: none">
					<input type="radio" name="scheduleType" value="7"
						style="display: none">
					<%-- ScheduleType.DATE --%>
					<table>
						<tr>
							<td><input type="text" id="otherDate" size="10" />
								MM/DD/YYYY</td>
						</tr>
					</table>
				</div>
			</td>
		</tr>
		<tr>
			<td align="right" nowrap>Start Time:</td>
			<td width="10px">&nbsp;</td>
			<td><select id="scheduleChangeStartTimeHour">
					<c:forEach begin="0" end="23" varStatus="loop">
						<option value="${loop.index}"><c:out
								value="${loop.index}" />
					</c:forEach>
			</select> hour(s) <select id="scheduleChangeStartTimeMinute">
					<c:forEach begin="0" end="59" varStatus="loop">
						<option value="${loop.index}"><c:out
								value="${loop.index}" />
					</c:forEach>
			</select> minute(s)</td>
		</tr>
	</table>
</div>

<div id="historyFieldsWrapper" style="display: none"
	title="Scheduled Job History">
	<table id="jobHistoryTable">
		<thead>
			<tr>
				<th>Start Date/Time</th>
				<th>End Date/Time</th>
				<th>Run By</th>
				<th>Status</th>
				<th>Exit Status</th>
			</tr>
		</thead>
		<tbody>
		</tbody>
	</table>
</div>

<div id="historyStatsFieldsWrapper" style="display: none"
	title="Completed Scheduled Job Statistics">
	<table cellpadding="5">
		<tr>
			<td align="right" style="font-weight:bold">Name:</td>
			<td><span id="statsName"></span></td>
		</tr>
		<tr>
			<td align="right" style="font-weight:bold">Statistics:</td>
			<td><textarea id="statsDetails" rows="10" cols="50"></textarea></td>
		</tr>
	</table>
</div>
