<%@ include file="inc_header.jsp"%>

<link rel="stylesheet" href="css/searchallqirs.css">

<script type="text/javascript">
	function printQIR() {
		var selected = $('#selectedQIR').val()
		if (selected != null) {
			window.open('qir.action?qirId=' + selected)
		}
	}

	function confirmCancel() {
		return confirm("All unsaved data will be lost. Are you sure you want to cancel?")
	}

	$(function() {
		$("#fromDateInput").datepicker()
		$("#toDateInput").datepicker()

		var table = $('#currentQIRS').DataTable({
			scrollY : "190px",
			paging : true,
			autowidth : true,
			searching : false,
			select : 'single',
			order : [ [ 1, "desc" ] ]
		});

		$('#currentQIRS tbody').on('click', 'tr', function() {
			var isSelected = $(this).hasClass('selected')
			var data = table.row(this).data()
			$('#selectedQIR').val(isSelected ? data[1] : '')
			refreshButtons()
		})

		$("#excel")
				.click(
						function() {
							var url = 'qirExcelExport.html'
							if ($('#selectedQIR').val() != '')
								url += '?qirId=' + $('#selectedQIR').val()
							var theFrame = $(
									'<iframe style="visibility: hidden; display: none" frameborder="0"></iframe>')
									.appendTo('body')
							theFrame.attr('src', url)
						})

		$("#Refresh").click(function() {
			$("#Search").trigger('click')
		})
	})

	function refreshButtons() {
		var selectedVal = $('#selectedQIR').val()
		var existingVal = selectedVal != ''
		$('#edit').css("display", existingVal ? "inline-block" : "none")
		$('#edit').attr(
				'value',
				qirMap[selectedVal].statusCode == "Withdrawn"
						|| qirMap[selectedVal].statusCode == "Closed" ? "View"
						: "Edit")
		$('#pdf').css("display", existingVal ? "inline-block" : "none")
	}

	function resetForm() {
		$("#tnInput").val('')
		$("#fromDateInput").val('')
		$("#toDateInput").val('')
		$("#facilitySelect").val('-1')
		$("#vendorSelect").val('-1')
		$("#typeOfComplaintSelect").val('-1')
		$("#statusSelect").val('-1')
	}

	var qirMap = new Object()
	<c:forEach items="${qirList}" var="qir">
	qirMap['${qir.id}'] = {
		statusCode : "<c:out value="${qir.qirStatusType}" />"
	}
	</c:forEach>
</script>

<form:form method="post" action="searchAllQirs.html" id="searchForm">

	<form:errors path="*" cssClass="errorBlock" id="errorBlock"
		element="div" tabIndex="0">
	</form:errors>

	<div id="leftCol">
		<table cellpadding="5">
			<tr>
				<td align="right"><h4 tabindex="0">Tracking Number:</h4></td>
				<td><form:input type="text" id="tnInput" path="id" /></td>
			</tr>
			<tr>
				<td align="right"><h4 tabindex="0">From Date:</h4></td>
				<td nowrap><form:input type="text" id="fromDateInput"
						path="fromDateAsString" /> <b>MM\DD\YYYY</b> <b>To Date:</b> <form:input
						type="text" id="toDateInput" path="toDateAsString" /> <b>MM\DD\YYYY</b></td>
			</tr>
			<tr>
				<td align="right"><h4 tabindex="0">Facility:</h4></td>
				<td><form:select id="facilitySelect" path="selectedFacilityId">
						<form:option value="-1">Select</form:option>
						<form:options items="${facilities}" />
					</form:select></td>
			</tr>
		</table>
	</div>
	<div id="rightCol">
		<table cellpadding="5">
			<tr>
				<td align="right"><h4 tabindex="0">Vendor:</h4></td>
				<td><sec:authorize ifNotGranted="Vendor">
				<form:select id="vendorSelect" path="selectedVendorId"
					style="width:150px">
					<form:option value="-1">Select</form:option>
					<form:options items="${vendors}" />
				</form:select>
			</sec:authorize>
			<sec:authorize ifAllGranted="Vendor">
				<div
					style="display: inline-block; margin-left: 8px; margin-bottom: 10px;">
					<c:out value="${user.vendor.name}" default="(none)" />
				</div>
			</sec:authorize></td>
			</tr>
			<tr>
				<td align="right"><h4 tabindex="0">Type of Complaint:</h4></td>
				<td><form:select id="typeOfComplaintSelect"
				path="selectedComplaintTypeId" style="width:150px">
				<form:option value="-1">Select</form:option>
				<form:options items="${dmpQirTypes}" />
			</form:select></td>
			</tr>
			<tr>
				<td align="right"><h4 tabindex="0">Status:</h4></td>
				<td><form:select id="statusSelect" path="selectedStatusTypeId"
				style="width:150px">
				<form:option value="-1">Select</form:option>
				<form:options items="${qirStatusTypes}" />
			</form:select></td>
			</tr>
		</table>
	</div>
	<div id="searchButtonContainer">
		<input type="submit" class="submitAnchor button" id="Search"
			value="Search" name="Search" tabIndex="0" /> <input type="button"
			class="submitAnchor button" value="Reset"
			onclick="javascript:resetForm()" />
	</div>
</form:form>

<form:form method="get" action="manageQirs.html" commandName="command">
	<div id="searchResultsTableContainer">
		<table class="stripe dt-head-left dt-body-left hover cell-border"
			id="currentQIRS">
			<thead>
				<tr>
					<th>Status</th>
					<th>TN</th>
					<th><img src="images/PaperClip_Black.png" alt="Attachment" />
					</th>
					<th>Headline</th>
					<th>Submitted Date</th>
					<th>Submitted By</th>
					<th>Facility</th>
					<th>Vendor</th>
				</tr>
			</thead>
			<tbody>
				<c:forEach items="${qirList}" var="qir">
					<tr>
						<td tabindex="0"><c:out value="${qir.qirStatusType}" /></td>
						<td tabindex="0"><c:out value="${qir.id}" /></td>
						<td tabindex="0"><c:if test="${qir.hasAttachments}">
								<img src="images/PaperClip_Black.png" alt="True" />
							</c:if></td>
						<td tabindex="0"><c:out value="${qir.headline}" /></td>
						<td tabindex="0"><c:out value="${qir.submittedDateAsString}" />
						</td>
						<td tabindex="0"><c:out value="${qir.submittedByName}" /></td>
						<td tabindex="0"><c:out value="${qir.facilityNumAndName}" />
						</td>
						<td tabindex="0"><c:out value="${qir.vendor}" /></td>
					</tr>
				</c:forEach>
			</tbody>
		</table>
	</div>

	<div id="submitButtonContainer">
		<input type="submit" class="submitAnchor button" id="edit"
			value="Edit" name="SearchAllEdit" /> <input type="button"
			class="submitAnchor button" id="pdf" value="PDF" name="PDF"
			onclick="printQIR()" />
		<sec:authorize ifAllGranted="National Administrator">
			<input type="button" id="excel" class="submitAnchor button"
				value="Excel" />
		</sec:authorize>
		<input type="button" class="submitAnchor button" id="Refresh"
			value="Refresh" name="Refresh" /> <input type="button"
			class="submitAnchor button" id="cancel" value="Cancel" name="Cancel"
			onclick="javascript:document.location.href='home.html'" /> <input
			id="selectedQIR" name="selectedQIR" type="hidden" value=" "
			path="selectedQIR" />
	</div>
</form:form>

